define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib'), lazyload = require('lazyload'), com = require('com');
    // 模块加载时执行
    exports.init = init;
    var M = {};
    var V = {
        'showMyAppStrategy' : function(objResult) {
            var arrList = objResult ? objResult.list : [];
            if (arrList.length) {
                arrList = com.formatMyAppList(arrList);
                $('#blkbox').hide();
                var $wrapper = $('#gamelistwrap');
                var $myApps = $wrapper.find('ul');
                // 我的游戏
                var $apps = $('#gamelistwrap').find('ul');
                var $html = $(lib.template2(arrList, '#my_apps_template'));
                $myApps.html($html);
                $wrapper.show();
                // 绑定延迟加载图片事件
                $html && $html.find('img').lazyload();
            } else {
                $('#blkbox').show();
                $('#gamelistwrap').hide();
            }
            $('#spinner_list').hide();
        }
    };
    var C = {
        'init' : function() {
            com.bindShowAppEvent('li[redirect]');
        }
    };
    // 初始化执行一次
    C.init();
    function init() {
        if (window.KalaGameGuide) {
            // 我的游戏攻略回调
            gc.showMyAppStrategy = function(objResult) {
                // 保存我的游戏
                // localStorage.setItem('myApps', JSON.stringify(objResult));
                V.showMyAppStrategy(objResult);
                lib.handleLoadPageReady();
            };
            // var strMyApps = localStorage.getItem('myApps');
            // var objMyApps = strMyApps && JSON.parse(strMyApps);
            // if (!objMyApps) {
                KalaGameGuide.getMyGame && KalaGameGuide.getMyGame();
            /* } else {
                V.showMyAppStrategy(objMyApps);
                lib.handleLoadPageReady();
            } */
        } else {
            V.showMyAppStrategy();
        }
        lib.bindScrollEvent();
    }
});
