define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib');
    
    exports.init = init;
    
    function init() {
        $('html').addClass('dialog');
		
		C.bindBackEvent();
 
        setTimeout(function() {
            var url = lib.getSessionItem('url_dialogUrl');
            $('#dialog #comIframe').attr('src', url);
            
	        //先把webview设置为Medium
	        if (window.KalaGame && KalaGame.setMediumZoom) {
	            console.log('setMediumZoom');
	            KalaGame.setMediumZoom();
	        }
            
            lib.showLoading();
            $('#dialog #comIframe')[0].onload = function() {
            	setTimeout(function() {
            		lib.hideLoading();
            	}, 200);
            };
        }, 100);
    }
    
    var C = {
        bindBackEvent : function() {
            // 回退时隐藏大图显示
            var historyCallback = gc.historyBack;
            gc.historyBack = function() {                
                $('html').removeClass('dialog');
                

                historyCallback();
                gc.historyBack = historyCallback;
                
                //把webview还原
                if (window.KalaGame && KalaGame.setFarZoom) {
                    console.log('setFarZoom');
                    KalaGame.setFarZoom();
                }
            };
        }
    };


});
