define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib');
    exports.init = init;

    var M = {
        sendFeedback : function(objData) {
            var strUrl = lib.bbsUrl + 'feedback/createFeedBack';

            lib.postCross(strUrl, objData, function(objResult) {
                if (objResult.result == 1) {
                    lib.showTip('反馈成功，感谢您的支持！');
                    lib.historyBack();
                } else {
                    lib.showTip(objResult.msg);
                }
            });
        }
    };

    var V = {};

    var C = {
        init : function() {
            $('#btn_send').on(gc.click, function() {
                var objData = lib.getFormData('#feedback');
                if (!objData) {
                    return;
                }
                M.sendFeedback(objData);
            });
        }
    };

    C.init();

    function init() {
        lib.handleLoadPageReady();
    }
});
