define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib');
    exports.init = init;
    var V = {
        'setFontSize' : function() {
            var strSize = localStorage.getItem('fontSize');
            var size = strSize || 24;
            // 初始化字体大小
            $('[fontSize="' + size + '"]').addClass('on');
        }
    };
    var C = {
        init                      : function() {
            C.bindChangeFontSizeEvent();
        },
        'bindChangeFontSizeEvent' : function() {
            $('#sizeList').on(gc.click, 'li', function() {
                var $this = $(this);
                var strSize = $this.attr('fontSize');
                $this.addClass('on').siblings('li').removeClass('on');
                localStorage.setItem('fontSize', strSize);
            });
        }
    };
    // 初始化执行一次
    C.init();
    function init() {
        V.setFontSize();
        lib.handleLoadPageReady();
    }
});
