define(function(require, exports, module) {
    var $ = require('jquery'), lib = require('lib'), slider = require('slider');
    var temp_replyId = null;
    /* 论坛表情 */
    var _path = gc.jsUrl + 'style/' + gc.theme + '/global/img/emotions/';
    var emotions = [
        {
            name     : '微笑',
            name_old : '',
            icon     : _path + '1.gif'
        },
        {
            name     : '可怜',
            name_old : '',
            icon     : _path + '2.gif'
        },
        {
            name     : '吐',
            name_old : '',
            icon     : _path + '3.gif'
        },
        {
            name     : '媚眼',
            name_old : '',
            icon     : _path + '4.gif'
        },
        {
            name     : '害羞',
            name_old : '',
            icon     : _path + '5.gif'
        },
        {
            name     : '尴尬',
            name_old : '惊恐',
            icon     : _path + '6.gif'
        },
        {
            name     : '狂汗',
            name_old : '',
            icon     : _path + '7.gif'
        },
        {
            name     : '恐慌',
            name_old : '',
            icon     : _path + '8.gif'
        },
        {
            name     : '生气',
            name_old : '',
            icon     : _path + '9.gif'
        },
        {
            name     : '昏',
            name_old : '',
            icon     : _path + '10.gif'
        },
        {
            name     : '流泪',
            name_old : '',
            icon     : _path + '11.gif'
        },
        {
            name     : '亲亲',
            name_old : '',
            icon     : _path + '12.gif'
        },
        {
            name     : '沉默',
            name_old : '',
            icon     : _path + '13.gif'
        },
        {
            name     : '无奈',
            name_old : '委屈',
            icon     : _path + '14.gif'
        },
        {
            name     : '傲慢',
            name_old : '',
            icon     : _path + '15.gif'
        },
        {
            name     : '冷汗',
            name_old : '',
            icon     : _path + '16.gif'
        },
        {
            name     : '大笑',
            name_old : '兴奋',
            icon     : _path + '17.gif'
        },
        {
            name     : '阴险',
            name_old : '',
            icon     : _path + '18.gif'
        },
        {
            name     : '难过',
            name_old : '',
            icon     : _path + '19.gif'
        },
        {
            name     : '讨厌',
            name_old : '',
            icon     : _path + '20.gif'
        },
        {
            name     : '巴掌',
            name_old : '耳光',
            icon     : _path + '21.gif'
        },
        {
            name     : '流汗',
            name_old : '汗',
            icon     : _path + '22.gif'
        },
        {
            name     : '发怒',
            name_old : '',
            icon     : _path + '23.gif'
        },
        {
            name     : '欣喜',
            name_old : '可爱',
            icon     : _path + '24.gif'
        },
        {
            name     : '口水',
            name_old : '',
            icon     : _path + '25.gif'
        },
        {
            name     : '吓',
            name_old : '',
            icon     : _path + '26.gif'
        },
        {
            name     : '呆',
            name_old : '发呆',
            icon     : _path + '27.gif'
        },
        {
            name     : '噢',
            name_old : '惊讶',
            icon     : _path + '28.gif'
        },
        {
            name     : '呲牙',
            name_old : '',
            icon     : _path + '29.gif'
        },
        {
            name     : '恶心',
            name_old : '',
            icon     : _path + '30.gif'
        },
        {
            name     : '困',
            name_old : '',
            icon     : _path + '31.gif'
        },
        {
            name     : '凶恶',
            name_old : '折磨',
            icon     : _path + '32.gif'
        },
        {
            name     : '狡诈',
            name_old : '邪恶',
            icon     : _path + '33.gif'
        },
        {
            name     : '得意',
            name_old : '',
            icon     : _path + '34.gif'
        },
        {
            name     : '鬼脸',
            name_old : '调皮',
            icon     : _path + '35.gif'
        },
        {
            name     : '扁嘴',
            name_old : '闭嘴',
            icon     : _path + '36.gif'
        },
        {
            name     : '撇嘴',
            name_old : '皱眉',
            icon     : _path + '37.gif'
        },
        {
            name     : '晕',
            name_old : '',
            icon     : _path + '38.gif'
        },
        {
            name     : '狡猾',
            name_old : '',
            icon     : _path + '39.gif'
        },
        {
            name     : '睡',
            name_old : '',
            icon     : _path + '40.gif'
        },
        {
            name     : '舌头',
            name_old : '',
            icon     : _path + '41.gif'
        },
        {
            name     : '色',
            name_old : '爱',
            icon     : _path + '42.gif'
        },
        {
            name     : '讶异',
            name_old : '惊吓',
            icon     : _path + '43.gif'
        },
        {
            name     : '鄙视',
            name_old : '',
            icon     : _path + '44.gif'
        },
        {
            name     : '酷',
            name_old : '',
            icon     : _path + '45.gif'
        },
        {
            name     : '钱',
            name_old : '',
            icon     : _path + '46.gif'
        },
        {
            name     : '锤子',
            name_old : '',
            icon     : _path + '47.gif'
        },
        {
            name     : '打雷',
            name_old : '',
            icon     : _path + '48.gif'
        },
        {
            name     : '问号',
            name_old : '',
            icon     : _path + '49.gif'
        },
        {
            name     : '红灯',
            name_old : '',
            icon     : _path + '50.gif'
        },
        {
            name     : '绿灯',
            name_old : '',
            icon     : _path + '51.gif'
        },
        {
            name     : '黄灯',
            name_old : '',
            icon     : _path + '52.gif'
        },
        {
            name     : '下雨',
            name_old : '',
            icon     : _path + '53.gif'
        },
        {
            name     : '刀',
            name_old : '',
            icon     : _path + '54.gif'
        },
        {
            name     : '咖啡',
            name_old : '',
            icon     : _path + '55.gif'
        },
        {
            name     : '喜欢',
            name_old : '',
            icon     : _path + '56.gif'
        },
        {
            name     : '嘴',
            name_old : '',
            icon     : _path + '57.gif'
        },
        {
            name     : '唇',
            name_old : '',
            icon     : _path + '58.gif'
        },
        {
            name     : '心碎',
            name_old : '',
            icon     : _path + '59.gif'
        },
        {
            name     : '感叹号',
            name_old : '',
            icon     : _path + '60.gif'
        },
        {
            name     : '拍手',
            name_old : '',
            icon     : _path + '61.gif'
        },
        {
            name     : '握手',
            name_old : '',
            icon     : _path + '62.gif'
        },
        {
            name     : '猪',
            name_old : '',
            icon     : _path + '63.gif'
        },
        {
            name     : '玫瑰',
            name_old : '',
            icon     : _path + '64.gif'
        },
        {
            name     : '电话',
            name_old : '',
            icon     : _path + '65.gif'
        },
        {
            name     : '灯泡',
            name_old : '',
            icon     : _path + '66.gif'
        },
        {
            name     : '笨猪',
            name_old : '',
            icon     : _path + '67.gif'
        },
        {
            name     : '月亮',
            name_old : '',
            icon     : _path + '68.gif'
        },
        {
            name     : '菠萝',
            name_old : '',
            icon     : _path + '69.gif'
        },
        {
            name     : '骷髅',
            name_old : '',
            icon     : _path + '70.gif'
        },
        {
            name     : '礼物',
            name_old : '',
            icon     : _path + '71.gif'
        },
        {
            name     : '严寒',
            name_old : '',
            icon     : _path + '72.gif'
        },
        {
            name     : '寒',
            name_old : '',
            icon     : _path + '73.gif'
        },
        {
            name     : '衰',
            name_old : '',
            icon     : _path + '74.gif'
        },
        {
            name     : '花',
            name_old : '',
            icon     : _path + '75.gif'
        },
        {
            name     : '香蕉',
            name_old : '',
            icon     : _path + '76.gif'
        },
        {
            name     : '雪糕',
            name_old : '',
            icon     : _path + '77.gif'
        },
        {
            name     : '胜利',
            name_old : '',
            icon     : _path + '78.gif'
        },
        {
            name     : '苹果',
            name_old : '',
            icon     : _path + '79.gif'
        },
        {
            name     : '饮料',
            name_old : '',
            icon     : _path + '80.gif'
        },
        {
            name     : '馒头',
            name_old : '',
            icon     : _path + '81.gif'
        },
        {
            name     : '西瓜',
            name_old : '',
            icon     : _path + '82.gif'
        },
        {
            name     : '烟花',
            name_old : '',
            icon     : _path + '83.gif'
        },
        {
            name     : '标记',
            name_old : '',
            icon     : _path + '84.gif'
        },
        {
            name     : '蒜头',
            name_old : '',
            icon     : _path + '85.gif'
        },
        {
            name     : '太阳',
            name_old : '',
            icon     : _path + '86.gif'
        },
        {
            name     : '爱心',
            name_old : '',
            icon     : _path + '87.gif'
        },
        {
            name     : '强',
            name_old : '',
            icon     : _path + '88.gif'
        },
        {
            name     : '差劲',
            name_old : '',
            icon     : _path + '89.gif'
        },
        {
            name     : '樱桃',
            name_old : '',
            icon     : _path + '90.gif'
        }
    ];
    var M = {
        'getWorkingHours' : function() {
            var strUrl = lib.openUrl + 'appmanage/getCustomerService';
            var objData = {};
            objData.appId = lib.getParam('appId');
            lib.postCross(strUrl, objData, function(objResult) {
                if (objResult.result == 1) {
                    V.showWorkingHours(objResult);
                } else {
                    lib.showTip(objResult.msg);
                }
            }, {
                'cache'     : true,
                'noLoading' : true
            });
        }
    }
    var V = {
        parseEmotionPath       : function(emotion) {
            var result = emotions.filter(function(em) {
                return (emotion == '[' + em['name'] + ']') || (emotion == '[' + em['name_old'] + ']');
            });
            if (result.length) {
                emotion = '<img src="' + result[0].icon + '" />';
            }
            return emotion;
        },
        parseUploadedImages    : function(strContent, objAttach) {
            var strHtml = strContent ? '<br />' : '';
            for (var key in objAttach) {
                strHtml += '<img data-original="' + objAttach[key] + '" />';
            }
            return strHtml;
        },
        showEmotions           : function(replyId) {
            var $wrap = $('#emotion_wrap');
            if ($wrap.hasClass('invisible')) {
                $wrap.removeClass('invisible');
            } else {
                $wrap.addClass('invisible');
                return;
            }
            var dataList = [];
            var $emotions = $('#emotionsBox');
            // 设置回复框
            var $replyBox = null;
            if (replyId) {
                temp_replyId = replyId;
                $replyBox = $('[contentId="' + temp_replyId + '"]').parent();
            } else {
                $replyBox = $('#btn_emotions').parent();
            }
            var offsetTop = $replyBox.offset().top;
            var barHeight = $('#top_bar').outerHeight(true) || 0;
            var scrollTop = document.body.scrollTop;
            var paddingBottom = parseInt($emotions.css('padding-bottom')) || 0;
            // 表情的规格
            var emotionWidth = 80, emotionHeight = 70;
            // 页面可用高度
            var height = offsetTop - barHeight - paddingBottom;
            // 表情框的宽度
            var width = emotionWidth * Math.floor($emotions.width() / emotionWidth);
            $emotions.width(width);
            // 要显示的表情行数和列数
            var col = Math.floor(width / emotionWidth), row = Math.floor(height / emotionHeight);
            // 页面可现实表情数量
            row = row > 3 ? 3 : row;
            var total = col * row;
            // 计算需要多少页现实表情
            emotionCount = emotions.length;
            var page = Math.ceil(emotionCount / total);
            var perPage = page > 1 ? total : emotionCount;
            for (var i = 0; i < page; i++) {
                var face_html = lib.template2(emotions.slice(perPage * i, perPage * (i + 1)), '#emotions_template');
                // 本行表情不足用空的格子补齐
                if (i == page - 1) {
                    // 要显示的总数
                    var acRow = Math.ceil(emotionCount / col);
                    var totalCount = col * acRow;
                    if (emotionCount < totalCount) {
                        var extraList = [];
                        for (var j = 0; j < totalCount - emotionCount; j++) {
                            extraList.push({});
                        }
                        face_html += lib.template2(extraList, '#extra_emotions_template');
                    }
                }
                dataList.push({
                    face_html : face_html
                });
            }
            var $html = lib.template2(dataList, '#emotions_page_template');
            $('#emotion_slider').html($html);
            var $btn = lib.template2(dataList, '#emotions_button_template');
            $('#emotion_button').html($btn);
            V.generateEmotionsSlider();
            C.bindSetEmotionPosEvent();
        },
        generateEmotionsSlider : function() {
            var options = {
                snapToChildren       : true,
                responsiveSlideWidth : true,
                navSlideSelector     : $('.iosSliderButtons .button'),
                onSlideChange        : V.switchSliderButton,
                onSliderLoaded       : V.switchSliderButton,
                onSlideComplete      : V.switchSliderButton
            };
            var $wrap = $('#emotion_wrap');
            var $emotions = $('#emotions');
            $wrap.removeClass('invisible');
            $emotions.iosSlider('destroy');
            $emotions.iosSlider(options);
        },
        switchSliderButton     : function(args) {
            var index = args.currentSlideNumber;
            var $buttons = $('#emotion_button .button');
            $buttons.removeClass('on');
            $buttons.eq(index).addClass('on');
        },
        showWorkingHours       : function(objResult) {
            var strWorkingHours = objResult.customerService;
            var $workingHours = $('#working_hours');
            if (strWorkingHours) {
                $workingHours.html(strWorkingHours);
                $workingHours.parent().removeClass('invisible');
            }
        }
    };
    var C = {
        bindSetEmotionPosEvent : function() {
            var $wrap = $('#emotion_wrap');
            var $emotions = $('#emotions');
            // 设置回复框
            var $replyBox = null;
            if (temp_replyId) {
                $replyBox = $('[contentId="' + temp_replyId + '"]').parent();
            } else {
                $replyBox = $('#btn_emotions').parent();
            }
            var offsetTop = $replyBox.offset().top;
            var barHeight = $('#top_bar').outerHeight(true) || 0;
            var scrollTop = document.body.scrollTop;
            var emoHeight = $wrap.outerHeight(true);
            var marginBottom = parseInt($('#sub_content').css('margin-bottom')) || 0;
            var replyBoxTop = offsetTop - scrollTop - emoHeight - marginBottom;
            if (replyBoxTop < barHeight) {
                $(window).off('scroll.emotion');
                $wrap.addClass('invisible');
                $('body').animate({
                    'scrollTop' : scrollTop - (barHeight - replyBoxTop)
                }, function() {
                    $wrap.css('top', barHeight + 'px');
                    $wrap.removeClass('invisible');
                    setTimeout(C.bindScrollEmotionEvent, 200);
                });
            } else {
                $wrap.css('top', replyBoxTop + 'px');
                C.bindScrollEmotionEvent();
            }
            // 修正表情选择框居中
            var $emotionsBox = $('#emotionsBox');
            var boxWidth = $emotionsBox.outerWidth();
            var margin = (window.innerWidth - boxWidth) / 2;
            $emotionsBox.css({
                'margin-left'  : margin + 'px',
                'margin-right' : margin + 'px'
            });
            // 修正箭头位置
            var $arrow = $emotionsBox.find('.arrow');
            var $btn_emotion = $replyBox.find('[rel]');
            var btnLeft = $btn_emotion.offset().left;
            var arrowLeft = btnLeft - margin + ($btn_emotion.width() - $arrow.width()) / 2;
            $arrow.css('left', arrowLeft);
            if (!temp_replyId) {
                $('body').on(gc.click, function(evt) {
                    if (!$('.subpost_wrap').find($(evt.target)).length) {
                        $('#emotion_wrap').addClass('invisible');
                        $('body').off(gc.click);
                    }
                });
            }
        },
        bindScrollEmotionEvent : function() {
            $(window).off('scroll.emotion').on('scroll.emotion', function() {
                $('#emotion_wrap').addClass('invisible');
            });
        },
        bindChooseEmotionEvent : function() {
            $('#emotion_wrap').off(gc.click, '[emotion]').on(gc.click, '[emotion]', function() {
                var $this = $(this);
                var emotion = $this.attr('emotion');
                var $content = null;
                $('#emotion_wrap').addClass('invisible');
                if (emotion) {
                    if (temp_replyId) {
                        $content = $('[contentId="' + temp_replyId + '"]');
                    } else {
                        $content = $('[name="content"]');
                    }
                    // 回复回帖
                    var content = $content.val() + emotion;
                    $content.val(content);
                    // 穿透问题
                    $content.attr('disabled', 'disabled');
                    setTimeout(function() {
                        lib.setCursorPos($content[0], content.length);
                        $content.removeAttr('disabled');
                    }, 300);
                }
                temp_replyId = null;
            });
        }
    };

    function showEmotions(replyId) {
        temp_replyId = null;
        C.bindChooseEmotionEvent();
        V.showEmotions(replyId);
    }

    // 修正输入框高度
    function updateHeight($this) {
        if ($this.next()[0].nodeName != "TEXTAREA") {
            var $shadom = $('<textarea type="text" style="position: absolute; border-width: 0px; padding: 0px; visibility: hidden;"></textarea>');
            $this.after($shadom);
        } else {
            var $shadom = $this.next();
        }
        $shadom.width($this.width());
        $shadom.val($this.val());
        setHeight();
        //setTimeout(setHeight, 0); //针对IE 6/7/8的延迟, 否则有时会有一个字符的出入
        function setHeight() {
            $this.height($shadom[0].scrollHeight);
        }
    }

    function init() {
        var lz = lib.removeParam("lz");
        lz && lib.setSessionItem('lz', lz);
        var isReverse = lib.removeParam("isReverse");
        isReverse && lib.setSession("isReverse", 1);
    }

    exports.emotions = emotions;
    exports.showEmotions = showEmotions;
    exports.parseEmotionPath = V.parseEmotionPath;
    exports.parseUploadedImages = V.parseUploadedImages;
    exports.updateHeight = updateHeight;
    exports.getWorkingHours = M.getWorkingHours;
    init();
});

