define(function(require, exports, module) {
    var $ = require('jquery'), zepto = require('zepto'), lib = require('lib');
    exports.init = init;
    var M = {
        createQuestion : function(params) {
            var url = lib.bbsUrl + 'feedback/createQuestion';
            params.appId = 10000;
            lib.postCross(url, params, function(response) {
                if (response.result == 1) {
                    lib.showTip('提交成功！');
                    lib.historyBack();
                } else {
                    if (response.ret == -6001) {
                        lib.showVcode(function() {
                            M.createQuestion(params);
                        });
                    }
                    // 失败，显示提示信息
                    lib.showTip(response.msg);
                }
            }, {
                'sendBtn' : '#e_submit'
            });
        },
        submitQuestion : function() {
            var data = lib.getFormData('#faq_subpost');
            if (!data) {
                return;
            }
            M.createQuestion(data);
        }
    };
    var V = {};
    var C = {
        init : function() {
            $('#e_submit').on(gc.click, function() {
                M.submitQuestion();
            });
        }
    }
    // 初始化执行一次
    C.init();
    function init() {
    }
});
