define(function(require, exports, module) {
    /*
     window.device = {
     uuid : "2cebd1c1f5af67a7"
     };
     */
    var $ = require('zepto'), md5 = require('md5');
    //公开给java调用的接口
    gc.historyBack = historyBack;
    gc.backToCharge = backToCharge;
    gc.checkRegister = checkRegister;
    gc.redirect = redirect;
    gc.setFarZoom = setFarZoom;
    gc.params = {};
    exports.showTip = showTip;
    exports.showLoading = showLoading;
    exports.hideLoading = hideLoading;
    exports.getParam = getParam;
    exports.getAllParam = getAllParam;
    exports.setParam = setParam;
    exports.removeParam = removeParam;
    exports.historyBack = historyBack;
    exports.clearHistory = clearHistory;
    exports.getAppInfo = getAppInfo;
    exports.getMyInfo = getMyInfo;
    exports.setTitle = _setTitle;
    exports.authLogin = authLogin;
    exports.setImgSize = setImgSize;
    exports.showOptMenu = showOptMenu;
    exports.showOriginalImg = showOriginalImg;
    exports.confirm = _confirm;
    exports.clearTimer = _clearTimer;
    exports.getSessionItem = _getSessionItem;
    exports.setSessionItem = _setSessionItem;
    exports.removeSessionItem = _removeSessionItem;
    exports.loadCustomizedStyle = _loadCustomizedStyle;
    exports.removeCustomizedStyle = _removeCustomizedStyle;
    exports.generateDateDiff = generateDateDiff;
    exports.updateHeight = updateHeight;
    exports.flushInputBoxes = flushInputBoxes;
    exports.postCross = postCross;
    exports.postCrossList = postCrossList;
    exports.postCrossIframe = postCrossIframe;
    exports.showCacheList = showCacheList;
    exports.showCacheList2 = showCacheList2;
    exports.template = template;
    exports.template2 = template2;
    exports.getFormData = getFormData;
    exports.init = init;
    exports.addFocus = addFocus;
    exports.strlen = strlen;
    exports.dateDiff = dateDiff;
    exports.dateDiff2 = dateDiff2;
    exports.setTimeout = _setTimeout;
    exports.setInterval = _setInterval;
    exports.bindScrollEvent = bindScrollEvent;
    exports.scrollEvent = function() {
    };
    exports.removeDuplicated = removeDuplicated;
    exports.listCountMultiples = listCountMultiples;
    exports.setCursorPos = setCursorPos;
    exports.getVersionString = getVersionString;
    /** 项目相关的js */
    exports.redirect = redirect;
    exports.redirectClient = redirectClient;
    exports.checkLogin = checkLogin;
    exports.dialog = dialog;
    exports.showVcode = showVcode;
    exports.showFormVcode = showFormVcode;
    exports.getOpenAuthInfo = getOpenAuthInfo;
    exports.setOpenAuthInfo = setOpenAuthInfo;
    exports.logout = logout;
    exports.getDefaultData = _getDefaultData;
    exports.showConfirmBind = showConfirmBind;
    exports.bindShowUserInfoEvent = bindShowUserInfoEvent;
    var payUrl = 'http://pay.api.kalagame.com/';
    var userUrl = 'http://user.api.kalagame.com/';
    var gameUrl = 'http://game.api.kalagame.com/';
    var openUrl = 'http://platform.api.kalagame.com/';
    var bbsUrl = 'http://bbs.api.kalagame.com/';
    var friendUrl = userUrl;
    exports.userUrl = userUrl;
    exports.payUrl = payUrl;
    exports.friendUrl = friendUrl;
    exports.gameUrl = gameUrl;
    exports.openUrl = openUrl;
    exports.bbsUrl = bbsUrl;
    var appId = getParam('appId') || 10000;
    exports.appId = appId;
    exports.imgFadeSpeed = 300;
    exports.maxImageHeight = 800;
    // 点击顺序
    var actionNo = 0;
    var parentPage = removeParam("parentPage") || "";
    //-------------------------------------------  相关实现   ------------------------------------------------
    /**
     * js获取url参数的值，(函数内部decodeURIComponent值)
     * @author benzhan
     * @param {string} name 参数名
     * @return {string} 参数值
     */
    function getParam(name) {
        //判断临时参数里面是否存在name
        if (typeof gc.params[name] != "undefined") {
            return gc.params[name];
        }
        //获取参数name的值
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
        //先获取#后面的参数
        var r = document.location.hash.substr(2).match(reg);
        if (r != null) {
            return decodeURIComponent(r[2]);
        }
        //再获取?后面的参数
        r = document.location.search.substr(1).match(reg);
        if (r != null) {
            return decodeURIComponent(r[2]);
        }
        return null;
    };
    function parseHash(name, strUrl) {
        strUrl = strUrl ? strUrl : document.location.hash;
        var pos = strUrl.indexOf('#!');
        strUrl = strUrl.substring(pos + 2);
        //获取参数name的值
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
        //先获取#后面的参数
        var r = strUrl.match(reg);
        if (r != null) {
            return [strUrl, decodeURIComponent(r[2])];
        }
        return [strUrl, null];
    };
    function getAllParam() {
        //获取url参数部分
        var searchPart = document.location.hash.substr(2);
        for (var name in gc.params) {
            if (!name) {
                searchPart = gc.params[name];
                continue;
            }
            //判断是否删除参数
            var isDelete = (name.indexOf('__') === 0);
            name = isDelete ? name.substr(2) : name;
            var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
            var r = searchPart.match(reg);
            if (isDelete) {
                //删除参数
                if (!r) {
                    continue;
                }
                //r[1]是匹配到的前缀，r[3]是匹配到的后缀
                searchPart = searchPart.replace(reg, r[3]);
            } else {
                //设置参数
                var value = encodeURIComponent(gc.params[name]);
                //如果r有值，则说明匹配上了
                if (r) {
                    //r[1]是匹配到的前缀，r[3]是匹配到的后缀
                    searchPart = searchPart.replace(reg, r[1] + name + '=' + value + r[3]);
                } else {
                    //如果没有匹配到，就直接后面加入
                    var prefix = searchPart ? '&' : '';
                    searchPart += prefix + name + '=' + value;
                }
            }
        }
        return searchPart;
    }

    function updateParam() {
        var searchPart = getAllParam();
        //更新后充值params
        gc.params = {};
        //设置到hash里面去
        document.location.hash = '!' + searchPart;
    }

    /**
     * js设置url中hash参数的值, (函数内部encodeURIComponent传入的value参数)
     * @author benzhan
     * @param {string} name 参数名
     * @return {string} value 参数值
     */
    function setParam(name, value, commit) {
        //是否commit到url里面，如果不是则只要写到params里面就可以了
        delete gc.params['__' + name];
        gc.params[name] = value;
        commit && updateParam();
    };
    /**
     * 删除锚点后的某个参数
     * @author benzhan
     * @param {string} name 参数名
     */
    function removeParam(name, commit) {
        //是否commit到url里面，如果不是则只要写到params里面就可以了
        var value = getParam(name);
        delete gc.params[name];
        gc.params["__" + name] = true;
        commit && updateParam();
        return value;
    };
    // 获取sessionStorage存储
    // function getSessionItem(item) {
    // var info = sessionStorage.getItem(item);
    // info = info && JSON.parse(info) || {};
    //
    // return info;
    // }
    // 获取游戏相关信息
    function getAppInfo(appId, callback) {
        var url = gameUrl + 'app/getAppInfo';
        var params = {
            appId : appId
        };
        postCross(url, params, function(response) {
            callback && callback(response);
        }, {
            cache : true
        });
    }

    // 获取当前登录用户的相关信息
    function getMyInfo(callback) {
        var url = userUrl + 'detail/getBaseInfo';
        postCross(url, function(response) {
            callback && callback(response);
        }, {
            cache     : true,
            noLoading : true
        });
    }

    function addFocus(selector) {
        selector = selector[0] || selector;
        var $this = $(selector);
        $this.addClass("hover");
        $this.one(gc.click, function() {
            $(this).removeClass("hover");
        });
    };
    //检查共有多少字符
    function strlen(s) {
        var l = 0;
        var a = s.split("");
        for (var i = 0; i < a.length; i++) {
            if (a[i].charCodeAt(0) < 299) {
                l++;
            } else {
                l += 2;
            }
        }
        return l;
    };
    function _getDefaultData(data) {
        data = data || {};
        data['token'] = localStorage.getItem('token');
        data['uid'] = localStorage.getItem('uid');
        data['openToken'] = getParam('openToken') || getOpenAuthInfo(appId, 'openToken');
        data['openId'] = getParam('openId') || getOpenAuthInfo(appId, 'openId');
        // 获取验证码
        data['imgVcode'] = localStorage.getItem('imgVcode');
        data.sdkVersion = getParam('sdkVersion');
        data.channel = getParam('channel');
        // 默认添加appId
        if (!data.appId) {
            data.appId = appId;
        }
        for (var k in data) {
            var v = data[k];
            if (v == null || typeof v === 'undefined') {
                delete data[k];
            } else {
                if (typeof v === 'string') {
                    data[k] = $.trim(v);
                }
            }
        }
        return data;
    }

    function _createCORSRequest(method, url) {
        var xhr = new XMLHttpRequest();
        if ("withCredentials" in xhr) {
            // "withCredentials"属性是XMLHTTPRequest2中独有的
            xhr.open(method, url, true);
        } else if (typeof XDomainRequest != "undefined") {
            // 检测是否XDomainRequest可用
            xhr = new XDomainRequest();
            xhr.open(method, url);
        } else {
            // 看起来CORS根本不被支持
            xhr = null;
        }
        return xhr;
    }

    function _saveAjaxCache(cacheKey, objResult, json) {
        // 如果请求成功并且有设置cache的ajax请求才缓存
        if (!cacheKey || !objResult.result) {
            return false;
        }
        var cache = localStorage.getItem(cacheKey);
        // serverTime的处理
        var cache_json = JSON.parse(cache);
        if (cache_json && cache_json.serverTime) {
            var serverTime = objResult.serverTime;
            delete cache_json.serverTime;
            delete objResult.serverTime;
            localStorage.setItem(cacheKey, json);
            if (JSON.stringify(cache_json) == JSON.stringify(objResult)) {
                return true;
            }
            objResult.serverTime = serverTime;
        }
        // 如果ajax的请求跟cache是一样的，则不需要调用回调了，直接退出
        if (cache == json) {
            //console.log('cache == json, so return;');
            return true;
        }
        //console.log('cache != json, localStorage.setItem, callback.');
        localStorage.setItem(cacheKey, json);
        return false;
    }

    function _loadAjaxCache(cacheKey, callback, time) {
        var cache = localStorage.getItem(cacheKey);
        if (cache) {
            var objResult = JSON.parse(cache);
            objResult._fromCache = true;
            objResult._time = time;
            callback(objResult, cacheKey);
            return true;
        }
        return false;
    }

    /**
     * @param response object 响应的数据
     * @param template string 列表模板
     * @param selector string/object 父容器的选择器
     */
    function showCacheList(responseData, $html, selector) {
        //判断是否是缓存的
        if (responseData._fromCache) {
            $html.appendTo(selector);
            //给旧的li增加时间标识
            $html.addClass('_time' + responseData._time);
        } else {
            //替换掉相同标识的数据
            var $oldHtml = $('._time' + responseData._time);
            if ($oldHtml.length) {
                var jq = jQuery || $;
                jq($oldHtml[0]).before($html);
                $oldHtml.remove();
            } else {
                $html.appendTo(selector);
            }
        }
    }

    function showCacheList2(response, template, selector, objOptions) {
        var $ = jQuery, responseList = response.list, $spinner = $('#spinner_list');
        // 返回结构中无list或list无数据时，不做处理
        if (!responseList || !responseList.length) {
            $spinner.hide();
            return;
        }
        var $list = $(selector), key = $list.attr('key'), existKeyList = {}, hasMore = response.hasMore;
        // 设置是否有下一页的标识
        $list.attr('hasMore', hasMore);
        if (!hasMore) {
            $spinner.hide();
        } else {
            // loading的显示控制
            $('#loadingText').css('visibility', 'hidden');
            $spinner.show();
        }
        // 列表去重
        var $latestItem = $(selector).find('> [latestItem]');
        // 从页面中清除已存在的
        if ($latestItem.length) {
            $latestItem.each(function() {
                var $this = $(this);
                var strItem = $this.attr(key);
                for (var i = 0, len = responseList.length; i < len; i++) {
                    if (strItem == responseList[i][key]) {
                        $this.remove();
                        break;
                    }
                }
            });
            $latestItem = $(selector).find('> [latestItem]');
        }
        // 页面存在的内容列表
        $list.find('>[' + key + ']').not('[latestItem]').each(function() {
            existKeyList[$(this).attr(key)] = 1;
        });
        // 从response中去掉已存在的
        if (!$.isEmptyObject(existKeyList)) {
            responseList = removeDuplicated(existKeyList, responseList, key);
        }
        var $html = $(template2(responseList, template));
        // 判断是否是缓存的
        var isReverse = objOptions ? objOptions['isReverse'] : 0;
        var isShowNewReply = objOptions ? objOptions['isShowNewReply'] : 0;
        if (response._fromCache) {
            if (!isReverse && $latestItem.length) {
                $html.insertBefore($latestItem.first());
            } else {
                var $children = $(selector).children();
                if (isShowNewReply && $children.length) {
                    $html.insertBefore($children.first());
                } else {
                    $html.appendTo(selector);
                }
            }
            // 给旧的li增加时间标识
            $html.addClass('_time' + response._time);
        } else {
            // 替换掉相同标识的数据
            var $oldHtml = $('._time' + response._time);
            if ($oldHtml.length) {
                var jq = jQuery || $;
                jq($oldHtml[0]).before($html);
                $oldHtml.remove();
            } else {
                if (!isReverse && $latestItem.length) {
                    $html.insertBefore($latestItem.first());
                } else {
                    var $children = $(selector).children();
                    if (isShowNewReply && $children.length) {
                        $html.insertBefore($children.first());
                    } else {
                        $html.appendTo(selector);
                    }
                }
            }
        }
        $list.removeClass('invisible');
        return $html;
    }

    /* 去除existList和responseList中相同的数据，返回existList中不存在的列表 */
    function removeDuplicated(existList, responseList, key) {
        var keyList = [];
        for (var j = 0, len = responseList.length; j < len; j++) {
            var item = responseList[j];
            if (existList[item[key]]) {
                continue;
            }
            keyList.push(item);
        }
        return keyList;
    }

    function postCrossIframe(url, data, formId, target) {
        var $form = $(formId);
        $form.attr('action', url);
        $form.attr('target', target);
        var $html = $(_buildData(data));
        $html.appendTo($form);
        $form[0].submit();
    };
    /** 构造post的参数 */
    function _buildData(data) {
        var html = '', data = _getDefaultData(data);
        // 设置origin
        if (parent && parent.location && parent.location.href) {
            var origin = 'http';
        } else {
            var origin = 'file';
        }
        data['__fromPostCross'] = origin;
        for (var key in data) {
            // 如果是null，则跳过
            if (data[key] === null) {
                continue;
            }
            var $field = $('[name="' + key + '"]');
            if (!$field.length) {
                html += '<input type="hidden" name="' + key + '" value="' + data[key] + '" />';
            } else {
                // 如果是文件则不需要设置
                if ($field.attr('type') === 'file') {
                    continue;
                }
                $field.val(data[key]);
            }
        }
        return html;
    }

    /**
     * option object {'cache', 'noLoading', 'sendBtn', 'onTimeout'}
     * cache为true、false、"must"
     */
    function postCross(url, data, callback, option) {
        option = option || {};
        // 支持postCross(url, callback)的写法;
        if (typeof data == 'function') {
            option = callback || {};
            callback = data;
            data = {};
        }
        // 防止多次点击
        var $sendBtn = $(option['sendBtn']);
        var hasSendBtn = !!$sendBtn.length;
        if (hasSendBtn) {
            if ($sendBtn.hasClass('ontimer')) {
                return;
            }
            $sendBtn.addClass('ontimer');
        }
        if (window.KLCommon && KLCommon.post) {
            KLCommon.post(url, data, function(objResult) {
                hasSendBtn && $sendBtn.removeClass('ontimer');
                callback(objResult);
            }, option);
            return;
        }
        data = _getDefaultData(data);
        data['__fromAjax2'] = 'ajax2';
        var time = (new Date()).getTime();
        //获取cache的key
        if (option['cache']) {
            var cacheData = $.extend({}, data);
            delete cacheData['token'];
            delete cacheData['openToken'];
            var cacheKey = 'ajaxCache-' + url + JSON.stringify(cacheData);
            //如果有cache则不出现loading
            var isCached = _loadAjaxCache(cacheKey, callback, time);
            if (isCached) {
                option['noLoading'] = true;
                if (option['cache'] == "must") {
                    return;
                }
            }
        }
        /*
         //坑爹，部分手机是wifi环境也显示是none，兼容性有问题
         //先读取缓存数据，如果没缓存才提示网络问题
         var net = navigator.network;
         if (!isCached && net && net.connection && net.connection.type == Connection.NONE) {
         showTip("当前网络不可用，请检查网络！");
         return;
         }
         */
        var xhr = _createCORSRequest('POST', url);
        xhr.url = url;
        //xhr.setRequestHeader("X-Requested-With", "XMLHttpRequest");
        xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
        if (window.KalaGame) {
            xhr.setRequestHeader("Cache-Control", "no-cache");
        }
        data = $.param(data);
        //console.log('post: ' + url);
        //console.log(data);
        option['noLoading'] || showLoading(15000, 500, xhr);
        xhr.send(data);
        xhr.onTimeout = option['onTimeout'] || function(xhr) {
            console.log(xhr.url + ' is time out.');
        };
        if (option['onTimeout']) {
            var timeoutHandler = waitTimeout(15000, xhr);
        }
        // 响应处理
        xhr.onload = function() {
            // 防止多次点击
            hasSendBtn && $sendBtn.removeClass('ontimer');
            option['noLoading'] || hideLoading();
            var text = xhr.responseText;
            //console.log('result:' + text.substr(0, 100));
            if (timeoutHandler) {
                clearTimeout(timeoutHandler);
            }
            var objResult = {};
            var objError = {
                result : 0,
                msg    : "系统错误，请稍后再试。"
            };
            try {
                objResult = JSON.parse(text);
                if (typeof objResult !== 'object' || objResult === null) {
                    objResult = objError;
                }
            } catch (ex) {
                //非json的处理
                objResult = objError;
            }
            // serverTime的处理
            var strPage = getParam('page');
            if (objResult.serverTime && strPage) {
                var page_arr = strPage.split('-');
                var module = require(page_arr[0] + '/js/' + page_arr[1] + '.js');
                var updateTime = module && module.updateTime;
                updateTime && updateTime(objResult.serverTime);
            }
            //如果没有cache或者cache失效，则需要调用callback
            if (!option['cache'] || !_saveAjaxCache(cacheKey, objResult, text)) {
                objResult._time = time;
                callback && callback(objResult, cacheKey);
                /*
                 //返回码为-6002表示过期的请求
                 if (!objResult.result && objResult.ret == -6002) {
                 var page = getParam('page');
                 if (page == 'user-login' || page == 'user-register') {
                 return;
                 }

                 // TODO : 刷新重定向到登陆页面问题
                 // logout();
                 }*/
                if (!objResult.result && objResult.ret == -201) {
                    showConfirmBind();
                }
            }
        };
        // 保存请求
        gc.pageXHR.push(xhr);
    }

    function showConfirmBind() {
        _confirm("您需要完善资料才能进入，马上完善资料？", function(index) {
            // 上报弹出绑定框
            gc.reportAction(getParam('page'), 'showConfirmBind', ++actionNo);
            switch (index) {
                case 1:
                    //设置为竖屏
                    window.KalaGameUi && KalaGameUi.setPortrait && KalaGameUi.setPortrait();
                    // 上报游客完善资料
                    gc.reportAction(getParam('page'), 'visitorCompleteInfo', ++actionNo);
                    redirectClient("user-complete_moreinfo");
                    break;
                case 2:
                    if (window.KalaGame && KalaGame.closeWebView) {
                        KalaGame.closeWebView();
                    } else {
                        historyBack();
                    }
                    break;
            }
        });
    }

    // 封装postCross仅供列表调用
    function postCrossList(url, data, callback, timeoutCallback, cache) {
        // 列表请求的默认配置
        var option = {
            cache     : ( typeof cache != 'undefined') ? cache : true,
            noLoading : true,
            onTimeout : function() {
                ajaxTimeoutCallback(timeoutCallback);
            }
        };
        postCross(url, data, callback, option);
    }

    // 列表请求超时回调，loading文字处理
    function ajaxTimeoutCallback(callback) {
        var $loading = $('#loadingText');
        $loading.html('加载超时了，点击刷新！');
        $loading.one(gc.click, function() {
            callback && callback();
            $loading.html('加载中...');
        });
    }

    /**
     * 简单的模板
     *
     * @param array
     *            data 有键值的数组
     * @param string/dom
     *            模板选择器
     */
    function template(data, selector) {
        selector = selector || document;
        var $doc = $(selector);
        for (var key in data) {
            var $item = $doc.find("[name='" + key + "']");
            if (!$item.length) {
                $item = $doc.find("#" + key);
                if (!$item.length) {
                    continue;
                }
            }
            $item.each(function() {
                var $this = $(this);
                switch ($this[0].nodeName) {
                    case 'INPUT':
                        var strType = $this.attr('type');
                        if (strType == 'checkbox') {
                            $this.prop("checked", data[key]);
                        } else if (strType == 'radio') {
                            break;
                        } else {
                            $this.val(data[key]);
                        }
                        break;
                    case 'TEXTAREA':
                    case 'SELECT':
                        $this.val(data[key]);
                        break;
                    case 'IMG':
                        // 设置默认图标
                        if ($this.attr('defaultIcon') == 'true') {
                            $this.attr('src', gc.defaultIcon);
                        }
                        if ($this.attr('data-original') != null) {
                            $this.attr('data-original', data[key]);
                        } else {
                            $this.attr('src', data[key]);
                        }
                        break;
                    case 'IFRAME':
                        $this.attr('src', data[key]);
                        break;
                    default:
                        $this.html(data[key]);
                }
            });
        }
    }

    /**
     * 强悍的js模板引擎
     * data：数组，异步请求回来的数据
     * tplSelector：模版选择器
     */
    function template2(data, tplSelector, desSeletor) {
        var tplValue = $(tplSelector).val() || $(tplSelector).text();
        if (!tplValue) {
            return;
        }
        //获取模版的内容，如  "<table><!-- <p>{id}</p><span>{name}</span> --></table>"
        var tplArr = tplValue.match(/<!--([\s\S]+)-->/);
        //例如：tplArr[0]="<!-- <p>{id}</p><span>{name}</span> -->"; tplArr[1]="<p>{id}</p><span>{name}</span>"
        var eachArr = [];
        //存储数组showArray里每个元素经过模版替换后的数组，如eachArr[0]='<p>123</p><span>aaa</span>'; eachArr[1]='<p>456</p><span>bbb</span>'
        $.each(data, function(i, e) {
            e.defaultIcon = gc.defaultIcon;
            e.defaultUserIcon = gc.defaultIcon_96;
            eachArr.push(tplArr[1].replace(/{(\w+)}/g, function(g, f) {
                return e[f] !== undefined ? e[f] : g;
            }));
        });
        var html = tplValue.replace(tplArr[0], eachArr.join(""));
        //替换到填充的位置上
        desSeletor && $(desSeletor).html(html);
        return html;
    };
    /**
     * 检查参数并获取表单数据
     * selector：表单选择器
     */
    function getFormData(selector) {
        var data = {};
        var $input = $(selector).find('input, select, textarea');
        $input.each(function() {
            if (!data) {
                return false;
            }
            var $this = $(this);
            var required = $this.attr('required');
            var inputVal = $.trim($this.val());
            if (required && !inputVal) {
                showTip('请输入' + $this.attr('title'));
                addFocus(this);
                data = false;
            } else {
                var key = this.name || this.id;
                if (key) {
                    if ($this.attr("type") == "checkbox") {
                        data[key] = $this.prop("checked");
                    } else if ($this.attr('type') == 'radio') {
                        data[key] = $('[name="' + $this.attr('name') + '"]:checked').val();
                    } else {
                        data[key] = $this.val();
                    }
                }
            }
            if (inputVal) {
                data && $this.attr('data-length') && ( data = _validateDataLength($this, data));
                data && $this.attr('data-type') && ( data = _validateDataType($this, data));
                data && $this.attr('data-reg') && ( data = _validateDataReg($this, data));
            }
        });
        return data;
    }

    function _validateDataLength($this, data) {
        var value = $.trim($this.val());
        // var length = strlen(value);
        var length = value.length;
        var reg = /(\d+),\s*(\d+|\+)/;
        var dataRange = $this.attr('data-length').match(reg);
        if (length < parseInt(dataRange[1])) {
            showTip('请输入' + dataRange[1] + '个字以上的' + $this.attr('title'));
            addFocus($this);
            return false;
        } else {
            if (parseInt(dataRange[2]) && length > parseInt(dataRange[2])) {
                showTip($this.attr('title') + '不能超过' + dataRange[2] + '个字');
                addFocus($this);
                return false;
            } else {
                var key = $this.attr('name') || $this.attr('id');
                if (key) {
                    data[key] = value;
                }
            }
        }
        return data;
    }

    function _validateDataType($this, data) {
        var value = $.trim($this.val());
        if (value) {
            var typeList = $this.attr('data-type').split('|');
            for (var i = 0, len = typeList.length; i < len; i++) {
                var reg = '';
                var type = typeList[i];
                if (type == 'email') {
                    reg = /\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*/;
                    if (!reg.test(value)) {
                        showTip('请输入合法的Email地址！');
                        addFocus($this);
                        data = false;
                    }
                } else if (type == 'tel') {
                    reg = /^1\d{10}$/;
                    if (!reg.test(value)) {
                        showTip('请输入正确的手机号码！');
                        addFocus($this);
                        data = false;
                    }
                } else if (type == 'num') {
                    reg = /^\d+$/;
                    if (!reg.test(value)) {
                        showTip('请输入数字！');
                        addFocus($this);
                        data = false;
                    }
                }
            }
        }
        return data;
    }

    function _validateDataReg($this, data) {
        var reg = new RegExp($this.attr('data-reg'));
        var value = $.trim($this.val());
        if (reg.test(value)) {
            var msg = $this.attr('data-regMsg') || '不符合规范哦！';
            showTip($this.attr('title') + msg);
            addFocus($this);
            data = false;
        }
        return data;
    }

    /**
     * 设置定时器
     * @param callback 定时器触发的函数
     * @param timeout 执行callback前的时间
     */
    function _setTimeout(callback, timeout) {
        var timer = setTimeout(callback, timeout);
        gc.pageTimers.timeout.push(timer);
        return timer;
    }

    function _setInterval(callback, timeout) {
        var timer = setInterval(callback, timeout);
        gc.pageTimers.interval.push(timer);
        return timer;
    }

    // 清除页面定时器
    function _clearTimer() {
        var len;
        var timeout = gc.pageTimers.timeout;
        var interval = gc.pageTimers.interval;
        len = timeout.length;
        if (len) {
            for (var i = 0; i < len; i++) {
                clearTimeout(timeout[i]);
            }
        }
        len = interval.length;
        if (len) {
            for (var i = 0; i < len; i++) {
                clearInterval(interval[i]);
            }
        }
        // 重置timer
        gc.pageTimers.timeout = [];
        gc.pageTimers.interval = [];
    }

    function _clearXHR() {
        var xhrs = gc.pageXHR, len = xhrs.length;
        if (len) {
            for (var i = 0, len; i < len; i++) {
                var xhr = xhrs[i];
                xhr && xhr.abort();
            }
        }
        // 重置
        gc.pageXHR = [];
    }

    /**
     * 打开对话框
     * @param url 对话框的url
     */
    function dialog(url, title) {
        _setSessionItem('url_dialogUrl', url);
        redirect('dialog', {
            title : title
        });
    }

    // 显示提示框
    function showTip(tip, timeout) {
        if (!tip) {
            return;
        }
        timeout = typeof timeout == 'number' ? timeout : 1500;
        if (window.KalaGame && KalaGame.showTip) {
            KalaGame.showTip(tip, timeout);
            return;
        }
        var $msg = $('.tip_msg', top.document);
        $msg.length || ( $msg = $('<span class="tip_msg"></span>').appendTo('body'));
        $msg.text(tip).show();
        _getTip($msg, timeout);
    };
    var tipTimeHandler = 0;

    function _getTip($msg, timeout) {
        var height = ($(document).height() - $msg.height()) / 2;
        var width = ($(document).width() - $msg.width()) / 2;
        $msg.css('top', height).css('left', width).show();
        tipTimeHandler && clearTimeout(tipTimeHandler);
        tipTimeHandler = setTimeout(function() {
            $msg.hide(500);
            tipTimeHandler = 0;
        }, timeout);
    }

    var delayHandler = timeoutHandler = 0;
    // 显示遮罩
    function showLoading(timeout, delay, xhr, timeoutCallback) {
        //超时时间默认为15s
        timeout = typeof timeout == 'number' ? timeout : 15000;
        delay = typeof delay == 'number' ? delay : 0;
        if (delay) {
            //清除上次的延时时间
            if (delayHandler) {
                clearTimeout(delayHandler);
                delayHandler = 0;
            }
            delayHandler = _setTimeout(loading, delay);
        } else {
            loading();
        }
        function loading() {
            //清除上次的过期时间
            if (timeoutHandler) {
                clearTimeout(timeoutHandler);
                timeoutHandler = 0;
            }
            console.log("showLoading, url:" + (xhr && xhr.url));
            //保留最近的一次超时回调
            timeoutHandler = _setTimeout(function() {
                timeoutHandler = 0;
                hideLoading();
                //中止ajax请求
                if (xhr) {
                    xhr.abort && xhr.abort();
                    xhr.onTimeout && xhr.onTimeout(xhr);
                }
                //console.log("request time out.");
                if (!$('.wrapper').length) {
                    //只有loadPageReady前超时时才能触发客户端的requestTimeout
                    if (window.KalaGame && KalaGame.loadPageReady && !KalaGame.loadPageReady.loaded) {
                        KalaGame.loadPageReady();
                        KalaGame.loadPageReady.loaded = true;
                    }
                    $('#requestTimeout').show();
                } else {
                    showTip('请求超时了！请稍后再试！');
                }
                if (window.KalaGame && KalaGame.requestTimeout) {
                    KalaGame.requestTimeout();
                }
                timeoutCallback && timeoutCallback();
            }, timeout);
            //console.log("showLoading");
            //显示loading
            if (window.KalaGame && KalaGame.showLoading) {
                if (!KalaGame.showLoading.loaded) {
                    KalaGame.showLoading();
                    KalaGame.showLoading.loaded = true;
                }
            } else {
                var $shade = _getShadow();
                $shade.show();
            }
        }
    }

    // 列表请求超时处理
    function waitTimeout(timeout, xhr) {
        // 超时时间默认为15s
        timeout = typeof timeout == 'number' ? timeout : 15000;
        if (xhr) {
            return _setTimeout(function() {
                xhr.abort();
                xhr.onTimeout && xhr.onTimeout();
            }, timeout);
        }
    }

    // 隐藏遮罩
    function hideLoading() {
        delayHandler && clearTimeout(delayHandler);
        timeoutHandler && clearTimeout(timeoutHandler);
        //隐藏loading
        if (window.KalaGame && KalaGame.hideLoading && KalaGame.showLoading.loaded) {
            KalaGame.hideLoading();
            KalaGame.showLoading.loaded = false;
        } else {
            var $shade = _getShadow();
            //console.log("hideLoading");
            $shade.hide();
        }
    }

    function _getShadow() {
        var $shade = $('#shade');
        if ($shade.length) {
            return $shade;
        }
        var html = '<div id="shade" class="loading" style="display:none;"><div class="pageprogress"><dl><dt>加载中...</dt><dd><span style="width:50%;"></span></dd></dl></div></div>';
        return $(html).appendTo('body');
    }

    function getVersionString() {
        var sdkVersion = getParam('sdkVersion');
        if (!sdkVersion) {
            return "";
        }
        var day = sdkVersion.substr(-2);
        if (day[0] == '0') {
            day = day[1];
        }
        if (sdkVersion.length >= 4) {
            if (sdkVersion.length == 5) {
                var year = sdkVersion.substr(-5, 1);
            } else {
                var year = 0;
            }
            var month = sdkVersion.substr(-4, 2);
            if (month[0] == '0') {
                month = month[1];
            }
        } else {
            var year = 0;
            var month = sdkVersion.substr(-3, 1);
        }
        return "V " + year + "." + month + "." + day;
    }

    /*************************    项目相关的私有公共js ***********************/
    //页面的缓存
    var pages = {}, inputValues = null, states = null, strOldPage = null;

    function _initEvent(page) {
        //加载历史的状态
        var temp = _getSessionItem('historyStates', true);
        states = temp && JSON.parse(temp) || [];
        //加载输入框的状态
        temp = localStorage.getItem('inputValues');
        inputValues = temp && JSON.parse(temp) || {};
        // 支持浏览器后退
        if (!window.KalaGame) {
            $(window).on('hashchange', function(ev) {
                var strOldHashURL = ev.oldURL;
                if (strOldHashURL !== ev.newURL) {
                    var strPage = getParam('page');
                    var arrHash = parseHash('page', strOldHashURL);
                    strOldPage = arrHash[1];
                    if (!strOldHashURL) {
                        if (!localStorage.getItem('uid')) {
                            strOldPage = 'user-login';
                        } else {
                            strOldPage = 'user-info';
                        }
                    }
                    if (!strPage) {
                        document.location.hash = '!' + arrHash[0];
                    } else {
                        _redirect(strPage, gc.redirectOption);
                    }
                }
            });
        }
        // 含有btn类的button，点击后有hover效果
        $('body').on('keydown', 'input[enterTarget]', function(event) {
            if (event.keyCode == 13) {
                var target = $(this).attr('enterTarget');
                if (!target) {
                    return;
                }
                this.blur();
                $(target).trigger(gc.click);
            }
        });
        //tab的点击事件
        $('body').on(gc.click, '[data-role]', function() {
            var $this = $(this);
            var role = $this.attr('data-role');
            switch (role) {
                case 'link':
                    var client = $this.attr('client');
                    var page = $this.attr('rel');
                    var param = $this.attr('param');
                    if (client && window.KalaGameUi && KalaGameUi.openActivity) {
                        if (!param) {
                            param = getAllParam();
                            //替换掉page参数
                            param = param.replace(/(^|&)page=([^&]*)/, '');
                        }
                        KalaGameUi.openActivity(page, param);
                    } else {
                        param && setParam('', param);
                        redirect(page);
                    }
                    break;
                case 'back':
                    gc.historyBack();
                    break;
            }
        });
        // 数据埋点
        $('body').on('click change', '[data-report]', function(event) {
            var $this = $(this);
            var eventType = $this.attr('data-report');
            if (eventType.indexOf(event.type) == -1) {
                return;
            }
            var page = getParam('page');
            var action = $this.attr('id') + '_' + event.type;
            var strActionKey = $this.attr('data-key');
            if (strActionKey) {
                action = strActionKey + '_' + event.type;
            }
            var strContent = '';
            if ($this[0].nodeName == 'INPUT' && !$this.attr('noReportConent')) {
                strContent = $this.val();
            } else {
                if (strActionKey) {
                    strContent = $this.attr(strActionKey);
                }
            }
            gc.reportAction(page, action, ++actionNo, strContent);
        });
        // 点击添加hover
        $('body').on(gc.touchstart + ' ' + gc.touchend, '[data-hover],.btn', _toggleHover);
        function _toggleHover(event) {
            var $this = $(this);
            //如果不能点击就去掉点击效果
            if ($this.hasClass("ontimer")) {
                return;
            }
            var hover = $this.attr('data-hover');
            if (hover == '') {
                return;
            } else if (!hover) {
                hover = 'hover';
            }
            var $parent = $this.parent();
            var touchmoveEvent = gc.touchmove + '.data-hover';
            if (event.type == gc.touchstart) {
                $this.parent().find('.' + hover).removeClass(hover);
                $this.addClass(hover);
                //增加touchmove的事件
                $('body').on(touchmoveEvent, '[data-hover],.btn', function(event) {
                    $parent.find('.' + hover).removeClass(hover);
                    //取消touchmove的事件
                    touchmoveEvent && $('body').off(touchmoveEvent);
                    touchmoveEvent = null;
                });
            } else {
                $this.removeClass(hover);
                touchmoveEvent && $('body').off(touchmoveEvent);
            }
        }

        /** 关闭窗口前的事件 */
        gc['onbeforeunload'] = function(event) {
            //上报关闭页面
            gc.reportAction(getParam("page"), "kalagame_destroy", ++actionNo);
            //保存页面的历史状态
            //            states.pop();
            //            _setSessionItem('historyStates', JSON.stringify(states), true);
            //保存页面的输入框状态
            _saveInputValues(getParam("page"));
            localStorage.setItem('inputValues', JSON.stringify(inputValues));
        };
        if (!window.KalaGame) {
            window.onbeforeunload = gc['onbeforeunload'];
        }
        // postMessage监听事件
        window.addEventListener("message", function(event) {
            var trustedOrigins = ['http://m.kalagame.com', 'http://bbs.api.kalagame.com', 'http://user.api.kalagame.com'];
            if (trustedOrigins.indexOf(event.origin) == -1) {
                return;
            }
            console.log('message:' + JSON.stringify(event.data));
            var eventData = event.data;
            if (typeof eventData == 'string') {
                gc[eventData] && gc[eventData]();
            } else {
                gc.msgCallback && gc.msgCallback(eventData);
            }
        }, false);
        _initWeb();
        if (window.KalaGame && KalaGame.saveConfig) {
            KalaGame.saveConfig(JSON.stringify(gc.pageInfos));
        }
        var uid = getParam('uid');
        var token = getParam('token');
        if (uid && token/* && !localStorage.uid && !localStorage.token*/) {
            localStorage.setItem('uid', uid);
            localStorage.setItem('token', token);
        }
    }

    /** 初始化web相关的事件 */
    function _initWeb(times) {
        if (window.KalaGame) {
            return;
        }
        //web的形式，对tab导航特殊处理
        $('.tbs').on(gc.click, function() {
            $('.weflex1').removeClass('on');
            $(this).parent().addClass('on');
        });
    }

    /* 选中页面 */
    function _checkTab() {
        if (window.KalaGame) {
            return;
        }
        var page = getParam('page');
        var $tab = $(".tbs[rel='" + page + "']");
        if ($tab.length) {
            $('.weflex1').removeClass('on');
            $tab.parent().addClass('on');
        }
    }

    function clearData() {
        var account = localStorage.account;
        var isOldUser = localStorage.isOldUser;
        localStorage.clear();
        sessionStorage.clear();
        // 登出后默认保留用户名
        account && localStorage.setItem('account', account);
        isOldUser && localStorage.setItem('isOldUser', isOldUser);
        clearHistory();
    }

    function logout() {
        clearData();
        if (window.KalaGame && KalaGame.logout) {
            showLoading();
            setTimeout(function() {
                hideLoading();
                KalaGame.logout();
            }, 800);
        } else {
            //刷新并重定向到登录页面
            document.location.href = "";
        }
    }

    function clearHistory() {
        _removeSessionItem('historyStates', true);
        states = [];
    }

    function historyBack() {
        gc.reportAction(getParam("page"), "historyBack", ++actionNo);
        window.history.back();
        console.log("history.length:" + history.length);
        if (history.length <= 1) {
            if (window.KalaGame && KalaGame.closeWebview) {
                console.log("KalaGame.closeWebview();");
                KalaGame.closeWebview();
            }
        }
    }

    function backToCharge() {
        var state = {};
        // 充值完成后返回的页面
        var backPages = ['pay-myaccount', 'pay-purchase'];
        var len = states.length;
        while (len--) {
            state = states.pop();
            if (state && (backPages.indexOf(state.page) != -1)) {
                redirect(state.page);
                return;
            }
        }
        historyBack();
    }

    function setFarZoom() {
        if (window.KalaGame && KalaGame.setFarZoom) {
            KalaGame.setFarZoom();
        }
    }

    function init() {
        if (getParam("needLogout")) {
            var url = userUrl + 'account/logout';
            postCross(url, function(objResult) {
                console.log("logout:" + JSON.stringify(objResult));
            });
            clearData();
        }
        if (getParam("noBorder")) {
            $('body').css("background-color", "#FFFFFF");
        }
        if (removeParam('isFirstEnter')) {
            //上报装机量
            gc.shmInstall();
        }
        var page = getParam('page') || "user-login";
        //初始化事件
        _initEvent(page);
        var pageInfo = gc.pageInfos[page] || [];
        pageInfo[4] && $('body').removeClass().addClass(pageInfo[4]);
        /*
         //如果有pwd则需要尝试登录
         if (!localStorage.pwd) {
         if (page == "user-login") {
         if (!localStorage.getItem('isOldUser') || !localStorage.getItem('token')) {
         //没有isOldUser，说明是没登录成功过，可直接显示页面
         redirect(page);
         }
         } else {
         //如果这个页面是不允许访问的，则需要验证
         pageInfo[1] && redirect(page);
         }
         }
         */
        if (getParam("noCheckLogin")) {
            redirect(page);
        } else {
            checkLogin();
        }
    }

    function _setTitle(title) {
        if (!title) {
            return;
        }
        document.title = title;
        if ($('#page_title').length) {
            $('#page_title').text(title);
        } else if (window.KalaGameUi) {
            KalaGameUi.setBarTitle(title);
        }
    }

    function redirectClient(page) {
        if (window.KalaGameUi) {
            var param = getAllParam();
            //替换掉page参数
            param = param.replace(/(^|&)page=([^&]*)/, '');
            KalaGameUi.openActivity(page, param);
        } else {
            redirect(page);
        }
    }

    function redirect(_page, option) {
        if (window.KalaGame) {
            _redirect(_page, option);
        } else {
            if (!_page) {
                return;
            }
            // 保存旧页面
            gc.redirectOption = option;
            var strHash = option && option.hash;
            if (strHash) {
                document.location.hash = strHash;
            } else {
                setParam('page', _page, true);
            }
        }
    }

    /**
     *  跳转页面
     *  @param string _page 页面
     *  @param array option array('replace', 'fromPage', 'popState')
     */
    function _redirect(_page, option) {
        option = option || {};
        pages[_page] = pages[_page] || {};
        if (window.KalaGame && KalaGame.redirectPage) {
            KalaGame.redirectPage(_page);
        }
        var pageInfo = gc.pageInfos[_page];
        if (pageInfo) {
            option['title'] || (option['title'] = pageInfo[0]);
            //不支持历史的后退按钮
            if (!pageInfo[2] && !option['noClear']) {
                states = [];
            }
        }
        // 清除页面定时器
        _clearTimer();
        // 清除上个页面未完成的请求
        _clearXHR();
        //修改按钮的文字，并控制显示
        _controlEditBtn(pageInfo);
        //是否移除旧状态，用于重新登录的逻辑
        if (option['popState']) {
            states.pop();
        }
        //如果fromPage与_page不相同时，增加fromPage
        if (option['fromPage'] && option['fromPage'] != _page) {
            setParam('fromPage', option['fromPage']);
        }
        // 是否显示排行榜等tab
        _handleRankTabs(pageInfo);
        if (!pages[_page]['dom']) {
            _getNewPage(_page, option);
        } else {
            _changePage(_page, option);
        }
    }

    // 控制排行榜等tab的显示
    function _handleRankTabs(pageInfo) {
        var last = pageInfo && pageInfo[pageInfo.length - 1];
        var tabs = last && last.tabs;
        if (!tabs) {
            $('#gamerank_tab').hide();
        } else {
            $('#page_title').html('');
            $('#gamerank_tab').show();
        }
    }

    /**
     * 控制按钮的显示，以及文字信息
     */
    function _controlEditBtn(pageInfo) {
        var objOther = pageInfo && pageInfo[pageInfo.length - 1];
        var strBtnText = objOther && objOther['editBtn'];
        var strBtnClass = objOther && objOther['btnClass'] || '';
        var $buttons = $('#buttons_container');
        // 清空按钮
        $buttons.html('');
        if (typeof strBtnText === 'string') {
            var strHtml = '';
            if (!strBtnText) {
                strBtnClass = strBtnClass ? strBtnClass : 'btn weflex1';
                strHtml += '<span id="btn_control" class="' + strBtnClass + '" onclick="gc[\'editBtnCallback\']()" data-report="click"></span>';
            } else {
                var arrBtnText = strBtnText.split('#');
                var strId, strCallback, strText, isBackGame, noBackGame;
                for (var i = 0, nLen = arrBtnText.length; i < nLen; i++) {
                    strText = arrBtnText[i];
                    isBackGame = (strText === '回游戏' || strText === '') && (i == nLen - 1);
                    // 不需要回游戏的按钮
                    noBackGame = getParam('noBackGame');
                    if (isBackGame && (noBackGame || !window.KalaGame)) {
                        continue;
                    }
                    if (isBackGame) {
                        strId = 'back_game';
                        strCallback = 'KalaGame.closeWebView();';
                    } else {
                        strId = 'btn_control' + i;
                        strCallback = "gc['editBtnCallback'](" + i + ');';
                    }
                    strHtml += '<span id="' + strId + '" class="btn weflex1 ' + strBtnClass + '" onclick="' + strCallback + '" data-report="click">' + strText + '</span>';
                }
            }
            $(strHtml).appendTo($buttons);
        }
    }

    function _pushState(_page, title) {
        var state = {
            page  : _page,
            title : title,
            hash  : document.location.hash
        };
        states.push(state);
    }

    function get(url, callback, option) {
        option = option || {};
        if (window.KLCommon && KLCommon.get) {
            KLCommon.get(url, callback, option);
            return;
        }
        var xhr = new window.XMLHttpRequest();
        xhr.url = url;
        option['noLoading'] || showLoading(10000, 500, xhr);
        xhr.onreadystatechange = function() {
            if (xhr.readyState != 4) {
                return;
            }
            if ((xhr.status >= 200 && xhr.status < 300) || xhr.status == 304 || (xhr.status == 0 && location.protocol == 'file:')) {
                option['noLoading'] || hideLoading();
                callback(xhr.responseText);
            }
        };
        xhr.open("GET", url);
        xhr.send();
    }

    function _getNewPage(_page, option) {
        var url = _page.replace('-', '/') + '.html?rand=' + (new Date()).getTime();
        var path = document.location.href;
        var pos = path.lastIndexOf("/");
        url = path.substr(0, pos + 1) + url;
        get(url, function(responseText) {
            if (responseText.content) {
                responseText = responseText.content;
            }
            //如果有页面信息时才缓存
            pages[_page]['dom'] = responseText;
            _changePage(_page, option);
        });
    }

    function _changePage(_page, option) {
        var $pageswarp = $("#pageswarp").removeClass("slide in");
        hideLoading();
        //修改新的页面连接
        setParam('page', _page, true);
        parentPage = (strOldPage == _page ? parentPage : strOldPage);
        //上报旧页面的销毁
        //parentPage && gc.reportAction(parentPage, "kalagame_stop", ++actionNo);
        // 重置页面的点击顺序
        actionNo = 0;
        //上报新页面的创建
        gc.reportAction(_page, "kalagame_start", ++actionNo);
        console.log("parentPage:" + parentPage + ", newPage:" + _page);
        _saveInputValues(strOldPage);
        var $wrap = $('.wrapper:first');
        if (strOldPage && $wrap.length) {
            //保存滚动条位置
            pages[strOldPage]['scrollTop'] = document.body.scrollTop;
            pages[strOldPage]['height'] = $pageswarp.height();
            var $fragment = $(document.createDocumentFragment());
            pages[strOldPage]['dom'] = $fragment.append($wrap);
        }
        //先隐藏旧的页面，再变背景色，然后换为新的页面
        var pageInfo = gc.pageInfos[_page];
        if (pageInfo) {
            $('body').removeClass();
            // 更改页面背景
            if (!getParam("noBorder")) {
                $('body').addClass(pageInfo[4]);
            }
            if (pageInfo[3]) {
                $('.pagetabs_wrap').show();
                $('body').removeClass("nobottom");
            } else {
                $('.pagetabs_wrap').hide();
                $('body').addClass("nobottom");
            }
            var other = pageInfo[pageInfo.length - 1];
            var $topbar = $('#top_bar');
            // var $content = $('#pageswarp');
            if (other['noTopBar']) {
                $topbar.hide();
                $('body').addClass('nativebox');
                // $content.height(document.body.clientHeight);
            } else {
                $topbar.show();
                $('body').removeClass('nativebox');
                // $content.height(document.body.clientHeight - $topbar.height());
            }
        }
        //修改新的页面连接
        //        setParam('page', _page, true);
        //设置标题放在最后面减少标题被后退按钮挤压产生抖动
        _setTitle(option['title']);
        //回调放在页面js的init方法之前执行，不然会覆盖init里面的setParam
        //        option['callback'] && option['callback']();
        var dom = pages[_page]['dom'];
        if (typeof dom == 'string') {
            var $dom = $(dom);
            pages[_page]['script'] = $dom.filter('script');
            $pageswarp.html($dom);
            //第一次打开的页面才需要恢复旧的输入的状态
            _loadInputValues(_page);
        } else {
            //还原高度、滚动条信息
            $pageswarp.height(pages[_page]['height']);
            if (option && option.isHistoryBack) {
                scroll(0, pages[_page]['scrollTop'] || 0);
            }
            //还原dom元素
            $pageswarp.html(dom);
            $pageswarp.append(pages[_page]['script']);
            $pageswarp.css('height', '');
        }
        // 修改高度
        setTimeout(function() {
            updateHeight($('.wrapper'), $('.wrapper'));
        }, 100);
        // 选中tab
        _checkTab();
        //不加新状态，后退按钮使用的
        if (!option['replace'] || !states.length) {
            _pushState(_page, option['title']);
        }
        //设置后退按钮
        _changeBackBtn(_page);
        // 当不是中验证码页面返回时，清除不保存的控件的值
        var imgVcode = localStorage.getItem('imgVcode');
        if (!imgVcode) {
            $('[noSave=true]').val('');
        }
        if (window.KalaGame && KalaGame.loadPageReady && !KalaGame.loadPageReady.loaded) {
            KalaGame.loadPageReady();
            KalaGame.loadPageReady.loaded = true;
        }
        // CSS3 动画转场效果
        //setTimeout(function() {
        $pageswarp.addClass("slide in").show();
        //}, 30);
        // 执行验证码回调
        if (_page != 'vcode' && imgVcode && gc.vcodeCallback) {
            gc.vcodeCallback();
            gc.vcodeCallback = null;
            localStorage.removeItem('imgVcode');
            $('[name=imgVcode]').remove();
        }
    }

    function _loadInputValues(page) {
        if (!inputValues[page]) {
            return;
        }
        for (var id in inputValues[page]) {
            $("#" + id).val(inputValues[page][id]);
        }
    }

    function _saveInputValues(page) {
        var selectors = ['input[id]:visible', 'textarea[id]:visible'];
        // 页面为null，则跳过
        if (!page) {
            return;
        }
        inputValues[page] = inputValues[page] || {};
        for (var i = 0; i < selectors.length; i++) {
            var $controls = $(selectors[i]);
            $controls.each(function() {
                var $this = $(this);
                var strType = $this.attr('type');
                if (strType !== 'password' && strType !== 'radio') {
                    inputValues[page][this.id] = $(this).val();
                }
            });
        }
    }

    function _changeBackBtn(_page) {
        var pageInfo = gc.pageInfos[_page] || [];
        //判断是否要显示后退按钮
        if (pageInfo[2] && window.history.length) {
            $(".btn_back").show();
        } else {
            $(".btn_back").hide();
        }
        //        if (states.length <= 1) {
        //            $(".btn_back").hide();
        //        } else {
        //            $(".btn_back").show();
        //        }
    }

    function authLogin(enterGame) {
        var req = getLoginArgs();
        if (!req) {
            return;
        }
        console.log('authLogin req:' + JSON.stringify(req));
        postCross(userUrl + 'account/login', req, function(data) {
            console.log('authLogin data:' + JSON.stringify(data));
            _clearTimer();
            // 随机码每次都要重新设置
            data.pwdRandom && localStorage.setItem('pwdRandom', data.pwdRandom);
            data.token && localStorage.setItem('token', data.token);
            data.uid && localStorage.setItem('uid', data.uid);
            data.openId && setOpenAuthInfo(appId, 'openId', data.openId);
            data.openToken && setOpenAuthInfo(appId, 'openToken', data.openToken);
            if (data.result == 1) {
                // 不存在openId，进入激活页面
                if (appId && appId != 10000 && !data.openId) {
                    redirect('user-activation');
                    return;
                }
                localStorage.setItem('isOldUser', 1);
                if (enterGame) {
                    if (window.KalaGame) {
                        KalaGame.session(data.uid, data.token, data.openId, data.openToken);
                    } else {
                        redirect('user-info');
                        // 去除登录注册的特殊样式
                        _removeCustomizedStyle(appId);
                    }
                    // 清除注册时保留的密码
                    localStorage.removeItem('pwd');
                    localStorage.removeItem('oldPwd');
                } else {
                    redirect('user-activenotice');
                }
            } else {
                //页面还没出来，需要显示
                if (!$('.wrapper').length) {
                    var page = getParam("page") || "user-login";
                    redirect(page);
                }
                if (data.ret == -6001) {
                    //这里是要显示验证码的情况
                    showVcode(function() {
                        authLogin(enterGame);
                    });
                }
            }
        });
    }

    function getLoginArgs() {
        var platformId = 1000;
        var pattern = checkGcAccount();
        if (!pattern) {
            return false;
        }
        var pwd = localStorage.getItem('pwd');
        var account = localStorage.getItem('account');
        var pwdRandom = localStorage.getItem('pwdRandom');
        var req = {};
        if (appId) {
            var openId = getOpenAuthInfo(appId, 'openId');
            var openToken = getOpenAuthInfo(appId, 'openToken');
            if (openId && openToken) {
                req.openId = openId;
                req.openToken = openToken;
            }
        }
        req.appId = appId;
        req.account = account;
        req.pwd = createPwd(pwd, pwdRandom);
        req.platformId = platformId;
        req.loginPattern = pattern;
        req['timeout'] = 1209600;
        req['uuid'] = window.device && device.uuid;
        return req;
    }

    function checkGcAccount() {
        var account = localStorage.getItem('account');
        var loginPattern = false;
        if (/^[0-9]{11,}$/.test(account)) {
            if (!/^1\d{10}$/.test(account)) {
                return false;
            }
            loginPattern = 2;
        } else if (/^[0-9]+$/.test(account)) {
            if (!/^[1-9][0-9]{4,10}$/.test(account)) {
                return false;
            }
            loginPattern = 1;
        } else if (/@/.test(account)) {
            if (!/^[a-zA-Z0-9_.]{1,30}@[a-zA-Z0-9-]{1,65}\.([a-zA-Z]{2,5}(\.[a-zA-Z]{2,3})?$)/.test(account)) {
                return false;
            }
            loginPattern = 3;
        } else if (account.length > 0) {
            return false;
        }
        return loginPattern;
    }

    function createPwd(sh1_pwd, random) {
        var newPwd = md5.xor(md5.sha1(random + md5.sha1(sh1_pwd)), sh1_pwd);
        newPwd = md5.base64encode(newPwd);
        return newPwd;
    }

    function checkLogin() {
        var req = {};
        var openId = getOpenAuthInfo(appId, 'openId');
        var openToken = getOpenAuthInfo(appId, 'openToken');
        req['appId'] = appId;
        req['uuid'] = window.device && device.uuid;
        if (openId && openToken) {
            req['openId'] = openId;
            req['openToken'] = openToken;
        }
        var strUrl = userUrl + 'account/checklogin';
        showLoading(15000, 500, {
            url : strUrl
        });
        //console.log('checkLogin req:' + JSON.stringify(req));
        postCross(strUrl, req, function(data) {
            //console.log('checkLogin data:' + JSON.stringify(data));
            data.token && localStorage.setItem('token', data.token);
            data.pwdRandom && localStorage.setItem('pwdRandom', data.pwdRandom);
            var page = getParam('page') || 'user-login';
            var pageInfo = gc.pageInfos[page] || [];
            if (data.result == 1) {
                // 清除注册时保留的密码
                localStorage.removeItem('pwd');
                localStorage.removeItem('oldPwd');
                //设置用户的状态
                localStorage.setItem('status', data.status);
                if (window.KalaGame && (page == "user-login")) {
                    //阻止迟来的showLoading
                    clearTimeout(delayHandler);
                    //客户端checkLogin不调用session
                    if (getParam("channel") != "client") {
                        //游戏中checklogin，需要判断这个登录是否在user-login页面
                        KalaGame.session(data.uid, data.token, req['openId'], req['openToken']);
                    } else {
                        _redirect(page);
                    }
                } else {
                    hideLoading();
                    if (page == 'user-login') {
                        _redirect('user-info');
                    } else if (!$('.wrapper').length) {
                        _redirect(page);
                    }
                }
            } else {
                hideLoading();
                //如果这个uuid有注册过
                if (data.hasUserId && !localStorage.account) {
                    if (getParam('channel') !== 'xiaomi') {
                        localStorage.setItem('account', data.mobile || data.email);
                    }
                }
                if (localStorage.pwd) {
                    //直接显示loading避免衔接不好
                    showLoading(15000);
                    //尝试自动登录，可能已经点击了激活码连接
                    authLogin(false);
                    //判断是否手机注册，需要检查短信是否接受过短信
                    if (localStorage.pattern == 1) {
                        window.KalaGame && KalaGame.checkSmsInbox();
                    }
                } else {
                    if (!pageInfo[1]) {
                        //这些页面需要跳到登录页面，登录后才重新跳转过来
                        _redirect("user-login", {
                            fromPage : page
                        });
                    } else {
                        _redirect(page);
                    }
                }
            }
        }, {
            noLoading : true
        });
    }

    // 获取openId和openToken
    function getOpenAuthInfo(appId, authType) {
        if (!appId || !authType) {
            return;
        }
        var authInfo = localStorage.getItem(appId);
        authInfo = JSON.parse(authInfo) || {};
        return authInfo[authType];
    }

    // 保存openId和openToken
    function setOpenAuthInfo(appId, authType, authVal) {
        if (!appId || !authType) {
            return;
        }
        var authInfo = localStorage.getItem(appId);
        authInfo = JSON.parse(authInfo) || {};
        authInfo[authType] = authVal;
        localStorage.setItem(appId, JSON.stringify(authInfo));
    }

    // 显示表单验证码
    function showFormVcode(strSelector) {
        var strPage = getParam('page');
        // 判断是否为发送激活码页面
        var isCheckRegister = (strPage == 'user-check_register');
        // 验证码类型
        var strVcodeType = isCheckRegister ? 'resend' : 'form';
        var $vcode = $('[vcodeType="' + strVcodeType + '"]');
        if ($vcode.length) {
            $vcode.remove();
        }
        get('./formVcode.html', function(strHtml) {
            var $html = $(strHtml);
            $html.insertBefore(strSelector);
            if (isCheckRegister) {
                $('[vcodeType="form"]').remove();
            } else {
                $('[vcodeType="resend"]').remove();
            }
            $html.show();
        });
    }

    // 显示验证码
    function showVcode(callback, cancelCallback) {
        // 点击确定的回调
        gc.vcodeCallback = callback;
        // 点击取消的回调
        gc.vcodeCancelCallback = cancelCallback;
        redirect('vcode', {
            title : '验证码'
        });
    }

    function dateDiff(serverTime, postTime) {
        var duration, d_minutes, d_hours, d_days;
        var obj = generateDateDiff(serverTime, postTime);
        // 时间对象相减得到毫秒数
        duration = parseInt(obj.duration / 1000);
        d_days = parseInt(duration / 86400);
        d_hours = parseInt(duration / 3600);
        d_minutes = parseInt(duration / 60);
        if (d_days > 365) {
            return postTime.slice(0, -3);
        } else if (d_days > 7 && d_days <= 365) {
            return "一周前";
        } else if (d_days > 0 && d_days <= 7) {
            return postTime.slice(5, -3);
        } else if (d_days <= 0 && d_hours > 0) {
            return d_hours + "小时前";
        } else if (d_hours <= 0 && d_minutes > 0) {
            return d_minutes + "分钟前";
        } else {
            return '几秒前';
        }
    }

    // 聊天列表处理
    function dateDiff2(serverTime, postTime) {
        var duration, d_minutes, d_hours, d_days;
        var obj = generateDateDiff(serverTime, postTime);
        // 时间对象相减得到毫秒数
        duration = parseInt(obj.duration / 1000);
        d_days = parseInt(duration / 86400);
        d_hours = parseInt(duration / 3600);
        d_minutes = parseInt(duration / 60);
        if (d_days > 365) {
            return obj.year + '年' + obj.month + '月' + obj.day;
        } else if (d_days > 1 && d_days <= 365) {
            return obj.month + '月' + obj.day + '日 ' + obj.hour + ':' + obj.minute;
        } else {
            return obj.hour + ':' + obj.minute;
        }
    }

    function generateDateDiff(strEndTime, strStartTime) {
        strEndTime = strEndTime || strStartTime;
        // strEndTime, 例如：2012-07-03 21:12:04 或 时间对象的实例
        var nDuration, objStart, objEnd, arrDateTime;
        // 待解析的年月日时分秒
        var nYear, nMonth, nDay, nHour, nMinute, nSecond;
        // 匹配时间串，得到相应的时分秒等等
        var rPattern = /(\d+)-(\d+)-(\d+) (\d+):(\d+):(\d+)/;
        // 生成相应的时间对象
        if (typeof strEndTime == 'object') {
            objEnd = strEndTime;
        } else {
            arrDateTime = strEndTime.match(rPattern);
            nYear = parseFloat(arrDateTime[1]);
            nMonth = parseFloat(arrDateTime[2]) - 1;
            nDay = parseFloat(arrDateTime[3]);
            nHour = parseFloat(arrDateTime[4]);
            nMinute = parseFloat(arrDateTime[5]);
            nSecond = parseFloat(arrDateTime[6]);
            objEnd = new Date(nYear, nMonth, nDay, nHour, nMinute, nSecond);
        }
        if (typeof strStartTime == 'object') {
            objStart = strStartTime;
        } else {
            arrDateTime = strStartTime.match(rPattern);
            nYear = parseFloat(arrDateTime[1]);
            nMonth = parseFloat(arrDateTime[2]) - 1;
            nDay = parseFloat(arrDateTime[3]);
            nHour = parseFloat(arrDateTime[4]);
            nMinute = parseFloat(arrDateTime[5]);
            nSecond = parseFloat(arrDateTime[6]);
            objStart = new Date(nYear, nMonth, nDay, nHour, nMinute, nSecond);
        }
        // 时间对象相减得到毫秒数
        nDuration = objEnd - objStart;
        // 返回对象
        var obj = {};
        obj.year = nYear;
        obj.month = nMonth;
        obj.day = nDay;
        obj.hour = nHour;
        obj.minute = nMinute;
        obj.second = nSecond;
        obj.duration = isNaN(nDuration) ? 0 : nDuration;
        return obj;
    }

    function bindScrollEvent(callback, $list) {
        //绑定滚动事件
        exports.scrollEvent = function() {
            if (typeof($list) == "function") {
                //为了支持多tab的页面
                $list = $list();
            }
            // 检查是否要加载新图片
            var flag = jQuery.updateLazyload();
            var $wrapper = $list.closest(".wrapper");
            var $loading = $wrapper.find('#spinner_list');
            var $loadingText = $wrapper.find('#loadingText');
            var isLoading = $loading.is(':visible') && $loadingText.css('visibility') == 'visible';
            var hasMore = $list.attr('hasMore') == 'true';
            if (!flag && !hasMore) {
                //取消滚动事件
                $(window).unbind('scroll.list');
                exports.scrollEvent = function() {
                };
                return;
            } else if (!hasMore || isLoading) {
                return;
            }
            if (window.KLCommon || document.height - (window.pageYOffset + window.innerHeight) <= 50) {
                $loadingText.css('visibility', 'visible');
                //这个是为了让页面刷新位置，不然拉到最低时，sk的手机会点击无效的问题。原因是position:fixed的元素错位了。
                $loadingText.css('height', $loadingText.height() + 1);
                $loading.show();
                _setTimeout(function() {
                    callback && callback($list);
                    //还原高度
                    $loadingText.css('height', $loadingText.height() - 1);
                    var $spinner = $list.closest(".wrapper").find('#spinner_list');
                    if ($list.attr('hasMore') != 'true') {
                        $spinner.hide();
                        return;
                    }
                }, 1000);
                // 上报加载更多
                gc.reportAction(getParam('page'), 'loadMore', ++actionNo, $list.find('>li').length);
            }
        };
        if (window.KLCommon && KLCommon.onScrollToBottom) {
            KLCommon.onScrollToBottom(exports.scrollEvent);
        } else {
            $(window).unbind('scroll.list').on('scroll.list', function() {
                exports.scrollEvent();
            });
        }
    }

    function shmData(data) {
        var rand = Math.floor(Math.random() * data.rate);
        //如果rand不等于0就不上报
        if (rand) {
            return;
        }
        var url = "http://data.api.kalagame.com:9070/";
        data.sdkVersion = getParam('sdkVersion');
        data.channel = getParam('channel');
        //data.model = getParam('model');
        //data.manufacturer = getParam('manufacturer');
        data.gameVersion = getParam('gameVersion');
        //console.log($.param(data));
        data = md5.base64encode($.param(data));
        $('<image />').attr('src', url + "?" + data);
    }

    gc.shmInstall = function() {
        var data = {};
        var device = window.device || {};
        data["__type"] = "install";
        //采样率为1，表示为百分百上报
        data.rate = 1;
        data.uuid = device.uuid;
        data.platform = device.platform;
        data.version = device.version;
        data.appId = getParam('appId');
        data.availableMem = getParam('availableMem');
        data.availableExternalStorage = getParam('availableExternalStorage');
        data.availableInternalStorage = getParam('availableInternalStorage');
        shmData(data);
    };
    gc.reportAction = function(page, action, actionNo, content) {
        var data = {};
        var device = window.device || {};
        data['__type'] = 'action';
        data.rate = 1;
        data.appId = getParam('appId') || 10000;
        data.page = page;
        data.parentPage = parentPage;
        data.action = action;
        data.actionNo = actionNo;
        data.uuid = device.uuid || '';
        data.uid = localStorage.getItem('uid') || '';
        data.openId = getOpenAuthInfo(appId, 'openId') || '';
        data.content = content || '';
        shmData(data);
    };
    // 设置默认列表加载数的倍数
    function listCountMultiples() {
        var MIN = 1, DH = 800, mul;
        mul = Math.ceil(window.innerHeight / DH);
        mul = mul < MIN ? MIN : mul;
        return mul;
    }

    // 检查手机验证码
    function checkRegister(inputVcode, needShowTip) {
        var platformId = 1000;
        var account = localStorage.getItem('account');
        var pwd = localStorage.getItem('pwd');
        if (!account || !pwd) {
            return;
        }
        var url = userUrl + 'register/checkRegister';
        var data = {
            inputVcode : inputVcode,
            platformId : platformId,
            uuid       : window.device && device.uuid,
            checkType  : localStorage.getItem("checkType")
        };
        console.log('checkRegister data:' + JSON.stringify(data));
        postCross(url, data, function(response) {
            console.log('checkRegister response:' + JSON.stringify(response));
            data.token && localStorage.setItem('token', data.token);
            data.uid && localStorage.setItem('uid', data.uid);
            data.openId && setOpenAuthInfo(appId, 'openId', data.openId);
            data.openToken && setOpenAuthInfo(appId, 'openToken', data.openToken);
            if (response.result == 1) {
                redirect('user-activenotice');
            } else {
                needShowTip && showTip(response.msg);
            }
        }, {
            noLoading : true
        });
    }

    // 设置光标位置
    function setCursorPos(ele, pos) {
        if (ele.setSelectionRange) {
            ele.focus();
            ele.setSelectionRange(pos, pos);
        } else if (ele.createTextRange) {
            var range = ele.createTextRange();
            range.collapse(true);
            range.moveEnd('character', pos);
            range.moveStart('character', pos);
            range.select();
        }
    }

    // 设置图片大小
    function setImgSize(html) {
        var $ = jQuery;
        var $images = html ? $(html).find('img') : $('img[data-original]');
        $images.each(function() {
            var $this = $(this);
            var src = $this.attr('data-original');
            if (!src) {
                return;
            }
            var size = src.match(/(\d+)\*(\d+)/);
            if (!size) {
                return;
            }
            // 设置图片宽高，使用缩略图尺寸
            var max_w = 160, max_h = 160;
            var size_w = size[1], size_h = size[2];
            if (size_w <= max_w && size_h <= max_h) {
                width = size_w;
                height = size_h;
            } else {
                if ((size_w / size_h) > (max_w / max_h)) {
                    width = max_w;
                    height = Math.floor(size_h / (size_w / max_w));
                } else {
                    height = max_h;
                    width = Math.floor(size_w / (size_h / max_h));
                }
            }
            $this.css({
                width  : width,
                height : height
            });
        });
    }

    function _confirm(msg, callback, title, buttonLabels) {
        //confirm
        if (_confirm.visible) {
            return;
        }
        buttonLabels = buttonLabels || "确定,取消";
        title = title || '提示';
        _confirm.visible = true;
        if (window.KalaGameUi) {
            KalaGameUi.confirm(msg, confirmCallback, title, buttonLabels);
        } else {
            //显示web的方法
            if (confirm(msg)) {
                confirmCallback(1);
            } else {
                confirmCallback(2);
            }
        }
        function confirmCallback(buttonIndex) {
            console.log("buttonIndex:" + buttonIndex);
            _confirm.visible = false;
            callback(buttonIndex);
        }
    }

    // 显示操作菜单
    /** @ type string 操作菜单类型
     *  @ option obj 选项：包含title、data及callback
     *
     */
    function showOptMenu(option, cancelCallback) {
        if (!option.data) {
            return;
        }
        var $menu = $('#_menu');
        var mType = option.optMenuType || '';
        var title = option.title;
        var dataList = option.data;
        var callback = option.callback;
        // 生成菜单
        var $html = $(template2(dataList, '#' + mType + '_menu_template'));
        // 绑定事件
        $html.each(function(i) {
            var $this = $(this);
            // 菜单选项
            var $item = mType == 'radio' ? $this.find('input') : $this;
            var data = dataList[i];
            var name = data.name;
            if (!mType) {
                // 添加属性
                name && $item.attr('qt', name);
            } else if (mType == 'radio') {
                if (name == option.value) {
                    $item.attr('checked', 'checked');
                }
            }
            // 绑定回调
            if (callback) {
                // 设置触发事件类型
                var evt = mType == 'radio' ? 'click' : gc.click;
                $item.one(evt, function() {
                    callback(name);
                    $menu.hide();
                });
            }
        });
        // 取消操作
        $('#_hide_menu').one(gc.click, function() {
            cancelCallback && cancelCallback();
            $menu.hide();
        });
        // 隐藏所有的菜单
        $('[optMenuType]').hide();
        // 显示当前类型菜单
        var $curMenu = $('[optMenuType="' + mType + '"]');
        if (mType == 'radio') {
            $('#' + mType + '_list').html($html);
            // 设置标题
            title && $('#' + mType + '_title').html(title);
            $curMenu.show();
        } else {
            $curMenu.html($html);
            $curMenu.show();
        }
        // 显示菜单
        $menu.show();
    }

    // 显示大图
    /** @obj 图片容器
     *
     */
    function showOriginalImg(obj, index) {
        // 图片列表
        var screenshots = {
            __screenshot : false,
            list         : []
        };
        // 设置当前点击图片的索引
        screenshots.index = index + 1;
        var $ = jQuery;
        jQuery(obj).find('img[data-original]').each(function() {
            var $this = $(this);
            var image = $this.attr('data-original') || $this.attr('src');
            screenshots.list.push({
                thumb  : image,
                normal : image.replace(/\.thumb\./, '.normal.')
            });
        });
        var list = screenshots.list;
        if (list.length == 1 && (list[0].thumb == gc.defaultIcon_96)) {
            showTip('不能查看默认头像！');
            return;
        }
        var json = JSON.stringify(screenshots);
        localStorage.setItem('screenshots', json);
        if (window.KalaGameUi && KalaGameUi.startBigImgActivity) {
            KalaGameUi.startBigImgActivity(json);
        } else {
            redirect('game-screenshots');
        }
    }

    function _getSessionItem(key, isSession) {
        var objStorage = isSession ? sessionStorage : localStorage;
        var strItem = objStorage.getItem('temp_item');
        var objItem = strItem && JSON.parse(strItem);
        if (!objItem || ( typeof objItem[key] == 'undefined')) {
            return null;
        }
        return objItem[key];
    }

    function _setSessionItem(key, value, isSession) {
        var objStorage = isSession ? sessionStorage : localStorage;
        var temp_item = objStorage.getItem('temp_item');
        temp_item = temp_item && JSON.parse(temp_item) || {};
        temp_item[key] = value;
        return objStorage.setItem('temp_item', JSON.stringify(temp_item));
    }

    function _removeSessionItem(key, isSession) {
        var objStorage = isSession ? sessionStorage : localStorage;
        var temp_item = objStorage.getItem('temp_item');
        if (!temp_item) {
            return null;
        }
        temp_item = JSON.parse(temp_item);
        delete temp_item[key];
        return objStorage.setItem('temp_item', JSON.stringify(temp_item));
    }

    function _removeCustomizedStyle(appId) {
        if (!appId) {
            return;
        }
        //var strLoginStylePath = gc.loginStylePath[appId];
        var strLoginStylePath = gc.loginStylePath[10000];
        if (strLoginStylePath) {
            $('link[href*="' + strLoginStylePath + '"]').remove();
        }
    }

    function _loadCustomizedStyle() {
        if (!appId) {
            return;
        }
        var strLoginStylePath = gc.loginStylePath[appId] || gc.loginStylePath[10000];
        //var strLoginStylePath = gc.loginStylePath[10000];
        if (strLoginStylePath) {
            seajs.use(strLoginStylePath);
        }
    }

    function bindShowUserInfoEvent(selector) {
        var channel = getParam("channel");
        if (channel == "apple") {
            return;
        }
        // 点击用户头像，显示用户相关信息
        $(selector).on(gc.click, 'li img[userId]', function(event) {
            var $this = $(this);
            var userId_list = $this.attr('userId');
            if (userId_list == 0) {
                showTip('用户不存在！');
            } else {
                setParam('userId', userId_list);
                if (userId_list == gc.userId && channel != "mobage" && channel != "xiaomi") {
                    redirectClient('user-edit_info');
                } else if (channel == "client" && window.KalaGameClient && KalaGameClient.openHouse) {
                    KalaGameClient.openHouse(userId_list);
                } else {
                    redirectClient('user-userinfo');
                }
            }
            return false;
        });
    }

    // 获取CSS样式
    function getCssPropertyValue(el, strProperty) {
        var strValue = null;
        if (el.currentStyle) {
            strValue = el.currentStyle[strProperty];
        } else if (window.getComputedStyle) {
            strValue = document.defaultView.getComputedStyle(el, null)[strProperty];
        }
        return strValue;
    }

    // 拉伸背景高度
    function updateHeight($list, $section) {
        if ($section.length <= 0) {
            return;
        }
        var $wrapper = $('.wrapper').get(0);
        // 获得section距顶部的距离等
        var nTop = $section.offset().top;
        var nMargin = (parseInt(getCssPropertyValue($wrapper, 'margin-bottom')) || 0);
        var nBorder = (parseInt(getCssPropertyValue($section.get(0), 'border-top-width')) || 0) + (parseInt(getCssPropertyValue($section.get(0), 'border-bottom-width')) || 0);
        // 底部tab高度
        var nBottom = 0;
        if ($('.pagetabs_wrap').is(':visible')) {
            nBottom = $('.pagetabs_wrap').height();
        }
        var nListHeight = $list.height();
        var nAvaiHeight = window.innerHeight - nTop - nBottom - nMargin - nBorder;
        // console.log('window.innerHeight: ' + window.innerHeight + '\nnTop: ' + nTop + '\nnBottom: ' + nBottom + '\nnMargin: ' + nMargin + '\nnBorder: ' + nBorder);
        // 只在高度小于可见高度时处理
        if (nListHeight < nAvaiHeight) {
            $section.css('min-height', nAvaiHeight);
        } else {
            $section.css('min-height', '');
        }
        return nAvaiHeight;
    }

    function flushInputBoxes() {
        // 穿透问题，可能会选中输入框
        var $obj = $('.wrapper').find('input, textarea');
        $obj.attr('disabled', 'disabled');
        setTimeout(function() {
            $obj.removeAttr('disabled');
        }, 300);
    }
});

