create table message_t (
	id				  INTEGER PRIMARY KEY AUTOINCREMENT,
	serverId          integer default 0,
	uid			      text not null,
	flag			  integer default 0,
	status			  integer default 0,
	isReaded		  integer default 0,
	msgText	          text default'',
	icon	          text default'',
	nickName	      text default'',
	jsonText		  text,
	contentType		  integer default 0,
	createTime  	  numeric default 0,
	originalTime  	  numeric default 0,
	notifyType  	  integer default 0,
	acceptType  	  integer default 0
);

create table session_t (
    id                INTEGER PRIMARY KEY AUTOINCREMENT,
    nickName          text default'',
    uid               text not null,
    content           text default'',
    avatar            text default'',
    type              integer default 0,
    time			  numeric default 0,
    unreadCount       INTEGER default 0
);

create table request_t (
    _id               INTEGER PRIMARY KEY AUTOINCREMENT,
    nickName          text default'',
    uid               text not null,
    content           text default'',
    avatar            text default'',
    province		  text default'',
    city		  	  text default'',
    town		  	  text default'',
    province_id       integer default 0,
    cityi_d       	  integer default 0,
    type              integer default 0,
    time			  numeric default 0,
    unreadCount       INTEGER default 0,
    sub_type		  integer default 0,
    operate		  	  integer default 0,
    msgId		  	  integer default 0,
    gender			  integer default 2
);

create table system_msg (
    msgId   		  INTEGER PRIMARY KEY,
    msgType			  INTEGER default 4,
    isRead			  INTEGER default 0,
    userId			  INTEGER default 0,
    title          	  text default'',
    msgTime			  text default'',
    content           text default'',
    page              text default'',   
    param       	  text default'',
    creatTime         text default'',
    imgsUrl       	  text default''
);


