define(function(require, exports, module) {
    var $ = require('zepto'), lib = require('lib');
    exports.init = init;
    var M = {
        replyQuestion : function(data) {
            var $btn = $('#btn_reply');
            var btnDisabled = $btn.hasClass('ontimer');
            if (!btnDisabled) {
                var url = lib.bbsUrl + 'question/replyQuestion';
                data.appId = lib.getParam('gameId');
                data.questionId = lib.getParam('questionId');
                data.reply_content = $("#reply_content").val();
                $btn.addClass('ontimer');
                //lib.postCrossIframe(url, data, '#createReply', 'createReplyFrame');
                lib.postCross(url, data, function(response) {
                    $('#btn_reply').removeClass('ontimer');
                    if (response.result == 1) {
                        // 保存刚发的帖子信息
                        lib.setSessionItem('latestReply', JSON.stringify(response));
                        // 清空回复内容
                        $('#reply_content').val('');
                        lib.historyBack();
                        lib.showTip('回复成功！');
                    } else {
                        if (response.ret == -6001) {
                            lib.showVcode(V.submitReply);
                        }
                        // 失败，显示提示信息
                        lib.showTip(response.msg);
                    }
                });
            }
        }
    };
    var V = {
        submitReply : function() {
            var data = lib.getFormData('#faq_reply');
            if (!data) {
                return;
            }
            M.replyQuestion(data);
        }
    };
    var C = {
        init : function() {
            // 绑定显示帖子内容事件
            $('#btn_reply').on(gc.click, V.submitReply);
        }
    }
    // 初始化一次
    C.init();
    function init() {
    }
});
