define(function(require, exports, module) {
	var $ = require('zepto'), lib = require('lib');
	exports.init = init;

	// 默认平台ID
	var platformId = 1000;

	var M = {
		activate : function() {
			var url = lib.userUrl + 'register/checkAppActivationCode';
			var data = lib.getFormData('.inputidbox');
			if (!data) {
				return;
			}

			data.appId = lib.appId;

			// localStorage.setItem('activationCode', data.activationCode);
			lib.postCross(url, data, function(data) {
				if (data.result == 1) {
					data.openId && lib.setOpenAuthInfo(lib.appId, 'openId', data.openId);
					data.openToken && lib.setOpenAuthInfo(lib.appId, 'openToken', data.openToken);

					localStorage.setItem('isOldUser', 1);
					if (window.KalaGame) {
						KalaGame.session(data.uid, data.token, data.openId, data.openToken);
					} else {
						lib.redirect('user-info');
					}
				} else {
					if (data.ret == -6001) {
						// 这里是要显示验证码的情况
						lib.showVcode(M.activate);
					}
					lib.showTip(data.msg);
				}
			});
		}
	};

	var C = {
		init : function() {
			$('#submit').on(gc.click, M.activate);

			// var activationCode = localStorage.getItem('activationCode');
			// $('[name=activationCode]').val(activationCode);
		}
	};

	// 初始化执行一次
	C.init();

	function init() {
	}

});
